================================================================================
=                                                                              =
=            Notepad3 - light-weight Scintilla-based text editor for Windows   =
=                                                                              =
=                                                   (c) Rizonesoft 2008-2021   =
=                                                 https://www.rizonesoft.com   =
=                                                                              =
================================================================================
Rizonesoft Notepad3 --- CHANGELOG ---
================================================================================

--------------------------------------------------------
LEGEND:
--------------------------------------------------------
1) NEW: (Added, Feature, Optimize)
2) CHANGES: (Change, Enhancement)
3) FIXES: (Correction, Debug)
4) REMOVED: (Obsolete, Depreciate)
5) TRANSLATIONS (MUI): (New Language)

--------------------------------------------------------
ABBREVIATIONS:
--------------------------------------------------------
CED - (C)ompact (E)ncoding (D)etection (by Google)
GRE - (GRE)pWinNP3 Search in Files Tool
LEX - (LEX)illa Library
MUI - (M)ultilingual (U)ser (I)nterface
NLS - (N)ew (L)anguage (S)trings (need for translation)
ONI - (ONI)guruma Regex engine
SCI - (SCI)ntilla Library
SUP - (S)et(UP) / Installer Package
UCD - (UCD)ARDET is an Encoding Detector Library


========================================================
Current BETA/RC Version 5.21.1109.(build_#) (2021-11-09)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
[.###.#]- .
[.###.#]- .

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
[.###.#]- .
[1021.1]- On file restore, do not notify immediately, but check against stored file attributes.
[1015.1]- Remove the max win version check for undocumented DarkMode UxTheme methods.
[1015.1]- DarkMode enable up to Win11 build 22471.
[1015.1]- SQL Lexer bright and dark mode highlight color enhanced.
[.924.1]- Disable actively file change polling - rely on directory change notification by default.
[.924.1]- Allow [Settings2] "FileCheckInverval" to be zero(0), means no active file change polling.
[.923.2]- Enable context menu for Statusbar.
[.923.1]- Enable context menu for Menubar.
[.916.1]- Use "round nearest displayed digit" method for estimated file size display.
[.915.1]- Limit file size: 2GB (Until WideCharToMultiByte() / MultiByteToWideChar() INT32_MAX issues are clarified).

--------------------------------------------------------
CHANGES Versions in Tools or Libraries:
--------------------------------------------------------
[.802.1]- Update Lexilla Library (LEX) version 5.1.2 (2021-07-26).
[.726.1]- Update Scintilla Library (SCI) version 5.1.1 (2021-07-26).
[.726.1]- Update grepWinNP3 (GRE) version 2.1.8.39 (2021-07-26).
[.702.5]- Update Oniguruma Regex (ONI) engine version 7.0.0 (2021-06-23).

--------------------------------------------------------
FIXES:
--------------------------------------------------------
[.###.#]- .
[1030.1]- Wrong format for reporting number of replaced occurrences "In Selection".
[1030.1]- "grepWinNP3" not intended switching file size search settings (GRE).
[1023.1]- Key "Favorites=(path)" not added in "Setup" version.
[1021.1]- "grepWinNP3" not intended switching "AllSize" settings (GRE).
[1021.1]- Don't save default values for Caret and Whitespace.
[1015.1]- SQL Lexer dark mode highlight default colors.
[1015.1]- Disabled menu items if settings file itself is locked by file change notification.
[.927.1]- Over paint annoying menu-bar bottom line.
[.926.1]- Dark-mode system menu bar coloring (except bottom line).
[.925.1]- Correction of some wrong keyboard shortcut (Alt+ Up, Alt+ Down).
[.924.1]- Translucency (alpha) settings for white-space indicator.
[.915.1]- Dark mode aware auto-completion-list-box.
[.915.1]- Goto-Dialog: digit grouping of line/column numbers.
[.914.1]- Digit grouping for replace occurrences result dialog.
[.914.1]- Better hyperlink style in dark themes "Dark" and "Obsidian".
[.913.1]- Initial factory window position.
[.910.1]- Web-Action commands should use also user-defined app to open hyperlinks.
[.907.1]- Reset background color for "visible whitespace" if not defined.

--------------------------------------------------------
REMOVED:
--------------------------------------------------------
[.###.#]- .
[.924.1]- Remove deprecated "AutoReloadTimeout".
[.907.1]- Remove Old and deprecated Notepad3 and grepWin icons.

--------------------------------------------------------
TRANSLATIONS (MUI):
--------------------------------------------------------
[.###.#]- .
[.###.#]- .

--------------------------------------------------------
Hello everybody ! 😀
For our "Notepad3 Translation Projects", we are looking for motivated volunteers for many languages, 
with a priority to take over "(incomplete...)" translation projects:
- Bulgarian (bg-BG)
- Czech (cs-CZ)
- Finnish (fi-FI)
- Indonesian (id-ID) (incomplete...)
- Irish (ga-IE)
- Norwegian (nb-NO)
- Romanian (ro-RO)
- Spanish Latin America (es-419) (incomplete...)
- Turkish (tr-TR) (incomplete...)
- Ukrainian (uk-UA)
- Vietnamese (vi-VN) (incomplete...)
- etc...
Please, send me a PM (mailto:hpwamr51 @ gmail.com) if you are willing to help. 🤔
--------------------------------------------------------


========================================================
Version 5.21.905.1 (5 September 2021)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
[.816.1]- Add Configuration (Properties) Lexer: add style setting for Key (of Key-Value pair).
[.811.1]- Add "Notepad3 Replacement" on Windows 11 Insider Preview which works almost like with Windows 10:
          - Open (ext: .inf, .ini, .log, .ps1, .psd1, .psm1, .scp, .txt, .wtx, .compositefont, .css, .sct, .wsc).
          - Edit (ext: .bat, .cmd, .jse, .reg, .text, .vbe, .wsf).
[.809.1]- Configure other application to open hyperlink (instead of default browser).
[.805.1]- File URL forced to open in new window by (Ctrl+Alt+Click).
[.805.1]- File change notification, if removed current file is recreated.
[.805.1]- Allow definition of line number for file:/// URL (separator is ':' ).
[.804.2]- File change notification Dlg: add "Indicator (silent) option.
[.804.2]- Configurable File on disk Change/Deleted indicators for title bar.
[.726.1]- "grepWinNP3" (current grepWin dev) allow multiple search paths (GRE).
[.709.2]- Add "KiXtart" lexer (new in Lexilla) (LEX).
[.709.1]- Integrating style theme "Sombra" as factory default Dark-Mode theme.
[.525.1]- Add "Julia" lexer (new in Lexilla) (LEX).
[.506.1]- Base64 Encoding/Decoding.
[.428.1]- Custom ChooseColor resource definition.
[.426.1]- Prepare Application Manifest for to grant Identity for non-package desktop apps.
[.425.1]- Add file/dir exists/not-found to hyperlink tooltip (if file-url).
[.422.1]- Support Scintilla's new feature: indicator stroke width.
[.420.1]- TXT file for Translators to comunicate Line Mumbers of the "Added/Modified" strings.
[.420.1]- Code Color for the "Change date" of the "Added/Modified" strings to translate".
[.420.1]- More intermediate font weight constants added.
[.420.1]- Remove useless font stretch handling.
[.419.3]- Add font weights retina(450), semi-light(350) and extra-black(950).
[.419.2]- Line Comment Add/Remove commands, additonal to existing Toggle.
[.415.1]- Cut lines for rectangular and multi selection.
[.412.1]- Use 'Ctrl+' key to force dropping files into new instance (Ctrl+ for new instance).
[.402.1]- ScintillaWin horizontal mouse-wheel support.
[.331.2]- Provide Mono-Language IDs.
[.331.1]- Mono-Language compiler switch for MiniPath.
[.325.1]- Compiler switch to allow Mono-language binary (no MUI DLL loading).
[.324.1]- Exclusive Lock (write) Mode shown in windows title.
[.323.1]- Menu item for excusive File Locking (write, shared read).
[.323.1]- Decorator styling for Python files.
[.321.1]- Exclusive File Lock option.
[.301.1]- About Dlg: version info for split-off Lexilla component.
[.301.1]- About Dlg: Copy-Ver-Info-Btn : add Dark-Mode information.
[.301.1]- Some filesystem path vs. file:// URL helpers (backslash invert).
[.301.1]- Converter: File-System Path to URL and vice versa.

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
[.825.2]- Non themed app: edit-window frame visibility.
[.811.1]- Current Lexilla dev (chg: HTML(PHP) Lexer) (LEX).
[.811.1]- Scintilla Python generator methods for embeddable Python (SCI).
[.811.1]- MUI base language definition moved to solution's preprocessors (C/C++ & RC) defines.
[.803.1]- Optimized default style handling for settings file (Dark Mode).
[.803.1]- Adapted other Dark Mode Theme Files.
[.802.1]- Default FileWatchingMode from "don't care" to "notify by MsgBox".
[.721.1]- Adapded "Sombra" Dark Mode default color scheme.
[.721.1]- Rename "KiX Config" to "KiXtart Script".
[.703.1]- Enable Dark Mode feature for Win11 v21H2 Insider beta.
[.529.2]- Win10 Release-ID as string (allows 20H2 or 21H1).
[.529.1]- Improved Julia Lexer (LEX).
[.526.1]- Batch-Lexer + patching Markdown-Lexer (eolfilled header lines) (LEX).
[.526.1]- Scheme-Dlg: dynamic (alloc) Style-Backup handling.
[.525.1]- Update Lexilla Lib (bug fixes for Lexer: Markdown, Cmd/Batch) (LEX).
[.515.1]- "grepWinNP3" based on current grepWin ver (boost v1.76 , upd: sktoolslib).
[.515.1]- Add some more coding fonts to prefer over Consolas (if installed).
[.515.1]- Linker: hardware-enforced stack-protection.
[.513.1]- Canonicalize style section of .ini-settings.
[.512.1]- Keep found initial common base default font in .ini.
[.507.1]- Base64 Decoding: select source code-page for decoding.
[.507.1]- Base64: default Encoding/Decoding based on current code-page
[.427.1]- Color selection dialog: NP3 icon, positioning and dark-mode.
[.427.1]- Adjust standard colors for URL Hyperlink (better standard dark-mode visual).
[.425.1]- New default for hyperlink tooltip is OFF.
[.425.1]- Immediate indicator hover response (colordef-hotspot, hyperlink-tooltip, hex-code-tooltip).
[.422.1]- Code cleanup for Font and Style Selection.
[.421.1]- Prefer "Cascadia Code" font over "Consolas" font for default if installed (ligatures).
[.420.2]- Custom Font Selection Dialog.
[.419.2]- Comment BockEdit shortcut changed (Ctl+Alt+Q => Alt+Shift+Q).
[.419.2]- Comment has separate popup menu (Edit -> Selection).
[.419.1]- Move some Lexer related functions to other module.
[.419.1]- Enable compiler warnings level 4 and issue "Warnings as Errors" (for Lexilla, Scintilla, grepWinNP3).
[.417.1]- Remove short-note from wrap around match tooltip.
[.416.1]- Save bookmarks in file history in case of "Save as...".
[.416.1]- Minimize usage of deprecated LCID/LANGID for MiniPath.
[.415.1]- Cpp-Lexer fix merged from Lexilla (5b92f7219a9fe9fb0ae4c5cc19f57c39185e4074.
[.414.2]- Minimize usage of deprecated LCID/LANGID for Notepad3.
[.414.1]- New size "4MB" for "FileLoadWarningMB=4" (Styling and Syntax Highlighting are switched off).
[.413.2]- Configurable position offset on launching new instance.
[.413.1]- Clarify menu item string (only one instance per file).
[.413.1]- Drag-n-Drop: allow multiple files to drop.
[.413.1]- Drag-n-Drop: replace current file (Ctrl+ for new instance).
[.413.1]- Menu/shortcut: launch "New Empty Wnd" <-> "Duplicate Instance".
[.411.2]- Adapt to Scintilla v5.0.1 new translucent alpha color (marker).
[.406.1]- C/C++ Lexer: styles and keywords (LEX).
[.331.1]- Cleanup code: SplitUndoTransaction() on timeout resp. line-break.
[.329.1]- Turning "Line Comment Block Edit" from option into command (Ctrl+Alt+Q).
[.326.1]- Kotlin & Dart Lexer from Zufuliu's source.
[.323.1]- File Lock: exclusive write/change, shared read.
[.323.1]- Style color for triple strings in Python Lexer.
[.316.1]- Cleanup lexilla component.
[.311.1]- Using some more Scintilla direct call methods instead of SendMessage() thread independent calls. (SCI).
[.311.1]- Refactoring for splitting Lexilla from Scintilla (SCI).
[.303.1]- Renaming Spanish Mexican to Spanish Latin America (es-419) (MUI).
[.302.1]- More liberal Hyperlink scanner (no need for validation here!).
[.302.1]- RegEx API : retun matched pattern length too.
[.302.1]- Prevent Path to URL conversion, if Hyperlink RegEx pattern does not match.
[.301.1]- Enable Dark Mode feature for Win10 v21H1 insider beta.
[.301.1]- EOL-Mode: status-bar double-click : inverted cyclic change rotation CRLF -> LF -> CR.

--------------------------------------------------------
CHANGES Versions in Tools or Libraries:
--------------------------------------------------------
[.802.1]- Update Lexilla Library (LEX) version 5.1.2 (2021-07-26).
[.726.1]- Update Scintilla Library (SCI) version 5.1.1 (2021-07-26).
[.726.1]- Update grepWinNP3 (GRE) version 2.1.8.39 (2021-07-26).
[.702.5]- Update Oniguruma Regex (ONI) engine version 7.0.0 (2021-06-23).

--------------------------------------------------------
FIXES:
--------------------------------------------------------
[.903.1]- Broken relative paths in file history selection.
[.828.1]- Open color selection on Ctrl+Left mouse click on color indicator too.
[.828.1]- Change cursor hand on Ctrl key-Up.
[.827.1]- Broken "scroll undo/redo history via mouse (RMB+WHEEL)" feature.
[.827.1]- Don't jump on initial F/R Dialog on empty clipboard.
[.827.1]- Cursor hand on ctrl-keydown hover hyperlink.
[.826.1]- Show hand cursor on hyperlink after dwell time (if ctrl key pressed).
[.825.2]- Caret change to hand over hyperlink only if ctrl is pressed.
[.825.1]- Some minor corrections on visual appearance.
[.824.1]- Sync status bar font size on system font size change.
[.824.1]- Restore previous window position while DPI scaling changed meanwhile.
[.822.1]- Missing .ini must not have an assertion failure, allowed case here.
[.820.1]- Specify "/utf-8" compiler option for "Scintilla, Lexilla and grepWinNP3" projects.
[.813.1]- "grepWinNP3" project: post build step - xcopy .lang files to desired build output dir (GRE).
[.813.1]- Remove obsolete (by SCI Lib v5.1.1) settings.
[.809.2]- Size of visible whitespace style.
[.809.2]- Workaround for additional selection typing.
[.807.1]- RegEx line begin pattern stuck after zero-length replacement.
[.806.1]- Launching file URL (Alt+Click) with respect to flags "Reuse Window" and "Only one Instance per File".
[.805.1]- File URL tooltip.
[.804.1]- Config version dependent "FileWatchingMode" settings value.
[.804.1]- File change notification in Title Bar.
[.804.1]- Trigger reset file changed on disc flag.
[.724.1]- Remove multiple file Notification, if current file has been deleted.
[.723.1]- F/R-Dlg: show match while typing protected characters.
[.722.1]- Fixing "infinite" loop in Markdown Lexer.
[.722.1]- Forced file ext written to scheme export.
[.722.1]- File-ext writing to stxle .ini files only on export.
[.707.1]- Distinguish Win10 vs. Win11 using build number (>=22000).
[.529.2]- F/R Dialog regression: allow replace in selection (if selection not empty).
[.527.1]- Correct handling of F/R dialog pattern combo-box dropdown list.
[.527.1]- Minor fixes Markdown-Lexer.
[.513.1]- Go to doc begin after global indentation change.
[.513.1]- Minor enhancements for selection scroll to view.
[.513.1]- Optimized handling of multi-step undo/redo notifications.
[.512.1]- Slow line-break toggle.
[.511.2]- TinyExpr: expr need not start with blank.
[.511.2]- TinyExpr: UTF-8 to ANSI-CP-1252 conversion should yield invalid characters instead of blank or currency.
[.511.1]- Space-width, avgchar-width and tab-width calculation.
[.511.1]- Scintilla missing recalculation of space width (to get correct tab width for indentation).
[.511.1]- Revert to Scintilla std  tabwidth calculation on font changes.
[.511.1]- Preserve "2nd Common Base" styling state across restarts.
[.511.1]- Default style settings should not be written to .ini-file.
[.429.1]- Handling of "File Vars" vs. "Encoding Tags".
[.427.1]- Minor fixes around font redrawing.
[.423.1]- Add thread COM initializations.
[.423.1]- Adding DPI awareness to MiniPath (correct toolbar handling still open point).
[.423.1]- minor corrections for customized font selection dialog (dark-mode and dpi-awareness).
[.423.1]- DWRITE font allocation needs to font.family, not font.face name (Scintilla fix).
[.421.1]- Correcting regression for icon scaling.
[.421.1]- Rendering of "Relaunch Elevated" menu icon.
[.421.1]- Regression on schema color definition.
[.421.1]- Another bug retrieving Font SIze for Common Default vs. Lexer Specific.
[.420.2]- Bug retrieving Font SIze for Common Default vs. Lexer Specific.
[.420.2]- Font Name handling retrieved from Common-Default vs. Lexer-Specific.
[.420.1]- Copy multi-selection to clipboard: separate each match by line-break.
[.419.1]- Apply provided Scintilla patch.
[.419.1]- Stream comment for .AU3 files.
[.419.1]- "grepWinNP3": fix compiler warning Release Win32 (GRE).
[.416.2]- Workaround Scintilla text-rendering bug, if line-number margin width set to 0 (so use 1 instead).
[.416.1]- Save Schema config in case of inifile from scratch.
[.415.1]- Small correction to Line Cut feature (thin selection).
[.414.2]- Minipath uses NP3 preferred language, if not configured.
[.414.2]- Compiling mono-language compiler switch version.
[.414.1]- Std windows behavior for cascading new instances (if configured).
[.413.2]- Sticky Window Flag on launching new instance.
[.413.1]- Prevent duplicate instance, if setting does not allow.
[.412.1]- Lazy styling (no need for SCN_STYLENEEDED).
[.412.1]- Caret visibility on JumpTo() after file (re-)load.
[.412.1]- FileWatching (file change notification) in some special cases.
[.411.2]- Mark occurrences: no additional bookmarker -> use invisible marker instead of background marker.
[.407.2]- New comment doc styling for C++ lexer (used for C#, RC, JS and Java too).
[.407.1]- Center dialog in parent: for system dialog and if minimized (tray or taskbar).
[.406.1]- Mark all Occurrences in case of reopened F/R dialog.
[.406.1]- Center dialog in parent.
[.406.1]- "grepWinNP3": fix missing search flags (GRE).
[.326.1]- TinyExpr regresion inserting newline after equal sign.
[.325.3]- Possible busy-loop in Kotlin and Dart Lexer.
[.325.2]- Don't keep window top-most after returning from full-screen mode (F11 toggle).
[.325.1]- Compiler switch to allow mono language binary.
[.324.1]- Read-Only-Attribute cooperating with Exclusive-Write-Lock.
[.323.1]- Lexer "Python": fixing Format-Strings (f-strings).
[.321.1]- Regression with vertical slope definition.
[.321.1]- Some regressions around external file change notification.
[.316.1]- "grepWinNP3" Language-ID "[xx-YY]" exceeds 5 chars (e.g. [es-419]) (MUI).
[.312.2]- Limit ChooseFont Dlg to CF_SCALABLEONLY for DirectWrite Technology.
[.312.1]- Rectangular selection typing issue.
[.309.1]- Replacing the "RCdll.dll" file to avoid garbage chars in foreign languages (MUI).
[.309.1]- In ".zip" version, some filenames in "gwLng" folder are incorrectly displayed (MUI).
[.303.1]- Language "Spanish Latin America" identifier correction (es-LA -> es-419) (MUI).
[.302.1]- Hyperlink RegEx pattern fixed to use valid Unicode.
[.302.1]- Handle quotes for URL <-> file-system path conversion.
[.301.1]- "grepWinNP3": hide progress bar after search finisched (GRE).
[.301.1]- ShellExecute() lpVerb for open hyperlink (Ctrl+Click) set to "open.
[.301.1]- Data type mismatch.
[.301.1]- Decoding of url-encoded file Hyperlinks ("file://...").

--------------------------------------------------------
REMOVED:
--------------------------------------------------------
[.828.1]- Open color selection on Alt+Left mouse click on color indicator.
[.807.1]- Remove deprecated (no sensible use case) "overlapping find" option.
[.506.1]- "fontsValid" extension (closer to default scintilla code base).
[.420.1]- Remove useless font stretch handling.
[.419.2]- Removing the font-style string for font selection.
[.411.1]- Remove deprecated WinXP support (no horiz. mouse wheel).
[.311.1]- Obsolete SCI_LEXER preproc symbol / no need to link lexers in Scintilla.

--------------------------------------------------------
TRANSLATIONS (MUI):
--------------------------------------------------------
[.707.1]- Chinese Traditional (zh-TW).
[.417.1]- Greek (el-GR).
[.303.1]- Portuguese Brazilian (pt-BR).


========================================================
Version 5.21.227.1 (27 February 2021)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
[.205.1]- Use user locale for date/time insert format: can be menu switched to preferred UI language.
[.124.1]- Enable horizontal scrolling by "Shift + Mouse-Wheel".
[.117.1]- Show search wrap-around tooltip (issue #3038).
[1222.1]- Kotlin Source Lexer based on Zufuliu's Kotlin Lexer code base.
[1222.1]- Dart Lexer based on Zufuliu's Dart Lexer code base.
[1221.1]- TinyExpr: additional number parsing for binary (0b...) and octal (0o...) number formats.
[1109.1]- Extension ".pkb" to SQL Lexer.
[1012.1]- 'Dark Mode' support for Windows 10 20H2 Version 2009 (Build 19042).
[1004.1]- Open/Save file explorer dialog: populate file filter with current lexer supported file extensions.
[.929.1]- Minipath.ini: [Settings2] FocusLostOpacity=100 (opycity level on losing focus).
[.923.1]- Hotkey 'F3': use MRU latest item before clipboard content as search pattern if prior search pattern is empty.
[.922.1]- Support Lexer switching while Customize Schemes dialog is open.
[.921.1]- Expand current lexers style tree on customize schemes dialog startup.
[.920.1]- grepWinNP3: "Stay On Top" titlebar context-menu (GRE).
[.918.1]- Faster statusbar update response / avoid flickering.
[.917.2]- Reducing Titlebar, Toolbar and Statusbar flickering.
[.916.1]- Set Light/Dark Mode for grepWinNP3 execution (GRE).
[.916.1]- Customize Schemes: show selected theme title.
[.915.2]- DarkMode: remember DarkMode chosen Scheme/Theme for next start.
[.915.2]- Configurable Dark Mode colors (non Explorer-Theme, Owner-Drawn).
[.915.2]- Menu item to switch between Default and Dark-Mode.
[.915.2]- DarkMode: Toolbar, static checkbox/listbox control.
[.915.2]- Win10 DarkMode Awareness (initial development).

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
[.223.1]- MiniPath: support mouse xbuttons for browsing direction.
[.223.1]- Code styling reformat MiniPath sources (AStyle: OTBS).
[.219.1]- Simple Line Comment Toggle handles each line separately
[.219.1]- Menu move Line/Stream Comment items to Edit -> Selection top.
[.218.1]- Find/Repl dialog - refactoring and minor fixes.
[.213.1]- JSON5 enhancements to Scintilla's original JSON-Lexer.
[.211.1]- Statusbar Selection-Info: switch to byte (instead of character) counting for huge files.
[.205.1]- Use user locale for date/time insert format: insert date before time & tab separated.
[.124.1]- Tinyexpr evaluation of math constants "e" and "pi" not being separated from prepending text.
[.116.1]- Extent static find/replace/mark occurances pattern buffer to 4095 characters.
[1223.1]- Initial start screen resolution independent fixed base font size.
[1218.1]- Avoid wrap-around requester if there is no other possible occurrence.
[1214.1]- Behavior change: copy to clipboard on empty selection -> don't copy anything if current line is empty.
[1214.1]- Update keywords list in Style INNO Lexer.
[1211.1]- No error message after decline loading file of huge size.
[1201.1]- Renaming Chinese displayed encoding according to MIME/IANA.
[1118.1]- Sci_PositionCR type reverted to long for Win32 compatibility reasons.
[1001.1]- Rebase DarkMode module on delay load version branch of win32-darkmode project.
[.930.1]- Update the KeyWordList of lexers "C# Source Code" and "SQL Query".
[.930.1]- Bookmark Occurrences Colors changed to get perceptually distinct colors.
[.929.1]- Migration from CreateLexer() by ID to CreateLexer() by Name (Lexilla IFace5 conform) (GRE).
[.928.1]- TinyExpr format floating.point with non zero fractional part.
[.927.1]- TinyExpr: change format (allow longer integer before switching to mantissa/exponent format).
[.925.1]- Prepare for Lexilla Library (Scintilla v5) (SCI).
[.925.1]- Using @zufuliu's EOL Mode detection enhancement (no SSE2 or AVX2 specializations).
[.923.1]- Unify search-pattern retrieval: (0.selection)[F/R-DLG] - 1.previous-search/MRU-List - 2.clipboard.
[.920.1]- grepWinNP3: save changed "Stay On Top" settings on exit (GRE).
[.920.1]- First part of DarkMode Theme for MiniPath.
[.917.4]- Separate DarkMode window-backgr color from button-facecolor.
[.916.1]- Opacity level on loosing focus for grepWinNP3.
[.916.1]- TinyExpr: '%' operator: distinguish between modulo and percent operation by context.
[.915.3]- Due to lack of interest, "Notepad3DLL" is discontinued.
[.915.2]- User configurable "Web Action" menu item names.
[.205.2]- Update grepWinNP3 (GRE) version 2.1.6.34 (2021-02.05).
[.124.1]- Update Oniguruma Regex (ONI) engine version 6.9.7 (2021-01-24).
[1214.1]- Update Scintilla Library (SCI) version 4.4.6 (2020-12-01).

--------------------------------------------------------
FIXES:
--------------------------------------------------------
[.226.2]- URL-Decoding of file Hyperlinks ("file://...").
[.226.1]- Wrap-Around tooltip use correct encoding.
[.222.2]- Multi-Line movement: proceed to document end correctly.
[.222.2]- Toggle comment on empty selection at insertion point: keep position of selection end.
[.222.2]- MiniPath: Enable Mouse XButton usage ("browse back and forth").
[.220.1]- Toggle Comment: proper selection handling.
[.219.1]- Do not move selection on search pattern change if in Replace-Dlg.
[.219.1]- FJSON Lexer has comments enabled now.
[.219.1]- F/R-Dialog - allow multi-line clipboard paste to Replace String combobox too.
[.218.2]- F/R: fixes some issues around RegEx zero-length match/findings.
[.218.1]- ReplaceAll. avoid busy loop (infinity) while replacing zero-length-match (RegExpr).
[.218.1]- F/R dialog don't change selection by typing search pattern.
[.218.1]- F/R show wrap-around tooltip only if message boxes are hidden.
[.215.1]- JSON5 string line continuation.
[.212.1]- Context-Menu Handling in Release Mode.
[.211.1]- Burndown some VS Analyze Mode Infos/Warnings.
[.205.1]- Wildcard search: unintentional wrap around.
[.125.1]- AHKL lexer: visual brace matching mix-ups.
[.124.1]- InfoBox message icon DPI scaling.
[.122.1]- Tinyexpr functions and constants parsing.
[.116.1]- Buffer overrun while initializing structures.
[.116.1]- Fix Font Dialog (Size handling) problems (issue #3012).
[1219.1]- F/R dialog: Transform Backslash option glitch.
[1219.1]- F/R dialog: message box in case of not matching pattern.
[1218.1]- Multi-Replace using RegExpr and Group-References.
[1211.1]- Refactoring encoding detection: pure ASCII vs. 7-bit.
[1125.2]- File encoding analysis with 7-bit ASCII only.
[1125.2]- File save problem after switching encoding to GB2312 (52936).
[1116.1]- Initial path on OpenFile dialog (load file).
[1116.1]- Compiler complaints (new VS2019 version v16.8.1).
[1024.2]- Allow single character filename on command line.
[1012.2]- Disable Copy/Cut complete lines on partial multi-selection.
[1012.1]- Find/Repl all in range algo.
[1012.1]- Oniguruma flexible EOL handling (Win CRLF, Unix LF and Mac CR) (ONI).
[1012.1]- Replace all in range.
[1012.1]- Avoid file cache lost on power failure.
[1006.1]- Copy/Cut/Delete "Focused View" lines (clipboard).
[1006.1]- Cut/cop occurrences marker line(s) if marker in first line.
[1004.1]- Initial directory for open/save file Explorer dialog.
[1001.1]- TOML Lexer performance leak.
[.928.2]- Freezing of main window caused by mixed usage of Lexer Interfaces.
[.928.1]- Setting new IFace5 Lexer (should fix line/stream comment toggle issue #2912).
[.927.1]- Lexer file extensions maintained in standard config.
[.927.1]- grepWin language switching (github.com/stefankueng/grepWin/issues/199) (GRE).
[.926.1]- Clone full .ini-file path for forked new instance (GRE).
[.926.1]- grepWinNP3: wide char path names for language files (GRE).
[.925.1]- Stop file change notification on deleted files if save is rejected.
[.925.1]- Some RegEx engine fixes (current Oniguruma dev) (ONI).
[.923.1]- Performance leak in TOML Lexer.
[.923.1]- Customize Schemes title assembling.
[.922.1]- DarkMode switching while non-modal dialogs are active.
[.921.1]- TinyExpr: interpretation of '%' operator: allow "(...)" on rhs of modulo interpretation.
[.921.1]- TinyExpr: remove the need of blank for smart interpretation of '%' operator.
[.921.1]- Failed to set DarkMode for owner drawn ComboBoxEx controls.
[.921.1]- DarkMode: toolbar button text.
[.921.1]- Let DarkMode work with 20H2.
[.920.1]- grepWinNP3 new instance: read correct .ini-file (protable) (GRE).
[.918.2]- Fix Win7 start-up crash.
[.918.1]- Final default color correction (toolbar, statusbar and margin).
[.917.4]- Allow removing of compile pre-processing switch D_NP3_WIN10_DARK_MODE.
[.917.3]- Bring back themed ReBar (Toolbar parent) for Win7.
[.917.3]- Bring back themed ReBar (Toolbar parent) for Win10 using Light Mode (DarkMode not wanted).
[.917.2]- Win7 Toolbar background back to COLOR_BTNFACE, Win10 stays with COLOR_WINDOWS.
[.916.1]- Update Titlebar on document modified.
[.916.1]- Clean .ini-config for default values.
[.916.1]- Standard margin background colors.
[.915.2]- DarkMode: switch std. background and text color too.
[.915.2]- DarkMode support / init / settings handling.

--------------------------------------------------------
REMOVED:
--------------------------------------------------------
[.921.1]- TinyExpr: '%%' as percent operator is deprecated.

--------------------------------------------------------
TRANSLATIONS (MUI):
--------------------------------------------------------
[1028.1]- Hindi (hi-IN).


========================================================
Version 5.20.915.1 (15 September 2020)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
[.911.1]- Allow colon (:) as alternate divide operator to calculate TinyExpr.
[.825.1]- grepWinNP3: default extension on saving search result list.
[.824.1]- Focused-View: mode Fold-Only.
[.823.1]- Mark Occurrences: show additional Bookmark (Arrows).
[.823.1]- Bookmark context menu: clear marker type.
[.822.2]- FocusedView Options: Bookmarks/Line-Highlight & Folding.
[.821.1]- Bookmark margin context menu.
[.819.1]- 1st version of Occurrences Bookmarks on Focused-View.
[.816.1]- Controls to clear history (file and find/replace).
[.815.1]- Using dialog RTL option for Main window too.
[.813.1]- Right-to-left (RTL) title/frame layout for some dialogs.
[.813.1]- Edit Right-To-Left (RTL) mode (works only in GDI device context (DC)).
[.812.1]- Extended context menu (margin commands, file explorer).
[.812.1]- Context-Menu to toggle margins.
[.811.1]- Color-Definition Hotspots: support RGB+A (default), A+RGB and BGRA.
[.808.1]- Configuration for "Search in Files" toolbar label. 
[.802.1]- Configuration ([Settings2]LargeIconScalePrecent) percent to switch to bigger file types icons.
[.727.1]- DPI-Aware treeview/listview lexer type icons.
[.727.1]- New string "Calculate Tiny-Expressions".
[.722.2]- ARM64_Build branch (Xperimental).

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
[.914.1]- F/R Dialog: toggle "Esc Ctrl Chr", try reverse operation if no length change
[.913.1]- Bad design: F/R dialog: remove auto Esc Ctrl Chr (changed to manual explicit).
[.901.1]- Open Recent File: Rename the Cancel button to Close button.
[.901.1]- grepWinNP3: alpha transparency on losing focus.
[.828.1]- Rearange and review "File Encoding" menu to clarify behavior.
[.826.1]- Default for file-encoding-tag parsing -> OFF.
[.826.1]- Swap file-encoding-tag parsing priority (encoding <-> coding).
[.825.1]- Revert Initial Font-Size based on DeviceCaps.
[.825.1]- Initial Font Size based on DeviceCaps (=> FullHD unchanged).
[.824.2]- grepWinNP3: Export search result list (NP3 enhancements).
[.823.1]- Delete Bookmarks (Alt+F2): 1st delete occurrence markers then std. bookmarks.
[.822.1]- Remove max count limitation for "Mark Occurrences" feature.
[.821.1]- Bookmark context menu on alpha-blend FocusedView marker line.
[.821.1]- Convenient message box text for normalizing EOLs.
[.817.2]- grepWinNP3 and minipath: special dialog box UI fonts for Asian languages.
[.816.1]- Use optimized Asian UI fonts for Notepad3 dialog boxes.
[.815.1]- Focused View: scroll to current position on each toggle.
[.805.1]- grepWinNP3: add OS architecture (x64) - AboutBox (GRE).
[.805.1]- Replace "64-bit"/"BETA" by "x64"/"beta" to shorter the version name.
[.803.1]- Title font change DPI-Awareness for About and Customize Schemes dialog.
[.802.1]- Resample scaling of info-box icons on DPI change.
[.802.1]- Revert System's Message box for "save confirmation" (if message beeps are allowed).
[.802.1]- High Quality Bitmap resampling method (Rizonesoft Bitmap).
[.729.1]- DPI-Aware About & Custom.Scheme dialog.
[.729.1]- Swap Shortcuts: "Search in Files" -> "Ctrl+Shift+F" and Toggle Folds -> "Ctrl+Alt+F".
[.723.1]- Review document modified handler (dirty-flag).
[.825.1]- Update grepWinNP3 (GRE) version 2.1.3.28 (2020-08-25).
[.813.1]- Update Oniguruma Regex (ONI) engine version 6.9.6 (2020-07-31).
[.818.1]- Update Scintilla Library (SCI) version 4.4.4 (2020-08-18).

--------------------------------------------------------
FIXES:
--------------------------------------------------------
[.914.1]- TinyExpr: crash on rectangular selection.
[.912.1]- TinyExpr: enable CP1252 operators '×'(mul) and '÷'(div).
[.912.1]- TinyExpr: ignoring currency chars ("$€¢£¥") in expressions.
[.912.1]- TinyExpr: "<n>=?" result not taken into account.
[.911.2]- TinyExpr: inline evaluation on active option only.
[.911.2]- TinyExpr: allow rh equal and questionmark.
[.911.2]- TinyExpr: newline after evaluation by '=<ENTER>'.
[.911.1]- Allow RETURN / ENTER after equal sign (=) to calculate TinyExpr.
[.908.1]- SubMenu active marker (Occurrences Indicator Options).
[.906.1]- Delete marker of (comletely) deleted lines.
[.905.1]- Initial state of "Focus View" button in F/R-Dlg.
[.901.2]- Buffer size calculation.
[.901.2]- Running out of occurrences bookmarks.
[.901.1]- Crash caused by buffer overflow.
[.831.1]- Recent File List (File History): Disable OK/Remove on empty list.
[.831.1]- Enhanced internal icon/bitmap handling.
[.830.1]- Remove needless function.
[.830.1]- F/R Dialog: Auto-Esc-Chars handling.
[.830.1]- F/R Dialog: Clear F/R History - remove entries from .ini-file too.
[.829.1]- Buffer to small in case of auto-esc ctrl-chars in find/replace edit-control.
[.825.2]- Wrong Focused-View Mode shown in menu.
[.825.2]- Try to fix (hardly reproducible) "copy Hyperlink issue (#2202).
[.825.1]- Regression: initial calculation of Print-Zoom factor.
[.824.1]- Not intended bookmarker on F/R dialog mark findings.
[.823.1]- Bookmark Occurrences too menu checked.
[.823.1]- Scroll to cursor for selection start/end jumps.
[.823.1]- Not intended "violet" bookmark.
[.821.1]- Context menu procedures for Occurrences Bookmarks on Focused-View.
[.819.3]- Single click in status bar's EOL segment will ask for consistent line-end change.
[.819.2]- Find any next/prev. bookmark (std or word).
[.818.1]- Scintilla bug fixes: SCICALL attribute (SCI).
[.817.1]- Reload language resource for about-box on init (maybe language changed).
[.815.1]- DPI Awarenes of window positions (default, sticky, ...).
[.813.1]- Center dialo in parent (if parent is minimized).
[.812.1]- Fix copy search for & path to (only one) existing instance (GRE).
[.812.1]- "grepWinNP3": fix invalid searchPath Ballon-Tip handling (GRE).
[.812.1]- [Settings2] filebrowser.exe=explorer.exe.
[.812.1]- Text contrast on hover color hotspot.
[.811.1]- Set preferred language to internal, on "not available confirmation dialog" is enabled.
[.808.1]- Center system's MessageBox in parent window. 
[.808.1]- Relative calculation of title font size for AboutBox and CS dialog. 
[.805.1]- Unicode Point detection and enhanced Color Tag contrast on hoover.
[.805.1]- DPI-Awareness of "Customize Schemes..." dialog icon eye sugar.
[.805.1]- DateTime and Timestamp handling.
[.803.1]- No read-only file attribute if removed externally.
[.802.1]- Some more DPI-Awareness issues.
[.801.1]- Ensure selection visible (scroll to current position).
[.801.1]- Extend selection to next find (Ctrl+Alt+F2).
[.801.1]- DPI-Awareness of About-Dlg (especially RichEdit-Ctrl).
[.801.1]- Non case sensitive style attribute search (find file extensions non case sensitive).
[.724.1]- Notepad3 should save (no ask) & exit on Shift+ESC Hotkey.
[.723.2]- Clear selection by ESC should not populate undo/redo stack.
[.722.2]- No document modified flag on forced re-decode file (recode) w/ other encoding.

--------------------------------------------------------
REMOVED:
--------------------------------------------------------
[.913.1]- Nop SendMsg.

--------------------------------------------------------
TRANSLATIONS (MUI):
--------------------------------------------------------


========================================================
Version 5.20.722.1 (22 July 2020)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
- grepWinNP3: export search results (GRE).
- changed grepWinNP3 icon (GRE).
- Add Toolbar icon for grepWinNP3.
- Configurable Zoom-Tooltip display timeout ([Settings2] ZoomTooltipTimeout=3200).
- Add Install/Remove "Open with Notepad3" to Notepad3 Setup/Installer (SUP).
- Add additional Dark Theme "Sombra".
- Strip first char: allow multi-selection.
- Open default browser while clicking tooltip (hovering hyperlink).
- Regex multi-select feature.
- Toolbar hot-button if view is zoomed (<>100%).
- Call-Back Notepad3 (from grepWinNP3) with case-sensitive and dot-match-all flag (if applicable).
- Add "Overlapping Search" in Find/Replace dialog window.
- Integration of external Search-In-Files tool named "grepWinNP3" (GRE).

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
- "grepWinNP3" About dialog wrapping long text (GRE).
- Silent ignore write permissions missing on Inifile.
- Replace non DPI Aware MessageBox for "Save on Close" by internal InfoBox
- Set DirectWite (D2D) rendering technology as new default.
- Two stage Toolbar reset (customizing dialog): 1st -> settings  2nd -> factory default.
- DPI_CHANGED msg handler.
- Enhancement of the "build_np3portableapp.cmd" file.
- Remove duplicate readme.txt, license.txt and unused files.
- Move all readme.txt, license.txt, KeyboardShortcuts.txt, etc... files
  from "Notepad3Portable\Other\Help" to "Notepad3Portable\App\Notepad3\Docs"
- Review and format the license.txt file for the dialogbox of INNO Installer.
- Font style/face-name handling.
- Extended Font selection dialog (Effects).
- Font selection refactoring.
- Revised grepWinNP3.ini file creation.
- Minor changes for dialog handling on DPI changed.
- Preparations for dpi-aware resizable "Customize Schemes..." dialog.
- DPI change handling: About & Schemes dialog.
- Markdown Lexer: new defaults for Header lines.
- Strip first char: do not apply on all text (empty selection).
- Reorganization Context menu.
- Bigger prev/next button-icons (Customize Schemes... dialog).
- Hyperlink double-click and MMB-click behavior.
- Filevar tag "fill-column" changes to support multi-column marker.
- Installer to let the user select the target directory.
- Changed Default long-line wrap settings.
- Remove spinning wait-cursor for text operations (may need reactivation for long operations).
- Add filepath to message on file locking error.
- Update grepWinNP3 (GRE) version 2.1.3.20 (2020-07-21).
- Update Oniguruma Regex (ONI) engine version 6.9.6 (2020/07/05).
- Update Scintilla Library (SCI) version 4.4.3 (2020/06/03).

--------------------------------------------------------
ENHANCEMENT:
--------------------------------------------------------
- "grepWinNP3": add "Dark mode" settings (GRE).
- "grepWinNP3": asynchronous search & replace version (GRE).
- DPI awareness and multi monitor handling.

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Alt+W (strip trailing blanks) should work w/o selection.
- TimeStamp handling.
- Menu selection operation (disable w/o selection).
- Move view to matching brace (even if outside current work area).
- Ask before overriding read-only protected configuration file.
- Respect read-only file attribute of .ini-settings-file (configuration).
- Undo/redo empty selection redundancy.
- Multiple line-/stream-selection undo/redo.
- Disabled Find/Replace or Customize Schemes (by modal child) dialog should disable main window.
- Printing scaling problem related to DPI awareness changes.
- System MessageBox "save before close" positioning.
- Reset of Toolbar configuration dialog.
- Crash if "close after find" is enabled.
- Keep current line on reverting file.
- Limit length of (manual) commit ID.
- DPI Aware relative positioning of position managed dialog boxes.
- DPI: awareness for Find/Replace-Dlg (remove resize property).
- DPI: awareness for Lexer-Selection-Dlg (remove resize property).
- DPI scaling for Scintilla surface component (thanx zufuliu).
- Unexpected selection of hyperlink in first line on empty doubleclick.
- Missing UI update (Margin Width).
- Don't overwrite grepWinNP3's user settings for backup in folders (GRE).
- Common base font inheritance for other styles.
- "grepWinNP3" crash on invalid file path (GRE).
- "vcxproj" should use the latest installed SDK.
- Scintilla as DLL solution.
- Extended font style selection.
- Don't add recent file list (history) to taskbar's jump-list.
- Fixing some CppCheck complaints.
- Broken x86 (32-bit) build.
- Theme scheme file handling (file extension inheritance).
- Remember find pattern (Ctrl+F3).
- Customize Toolbar dialog closes immediately.
- ".ini-file" acquire lock for invalid file path.
- Cancel multi-selection on line up/down key.
- Initial behavior on open Find/Replace dialog.
- Lost Find/Replace dialog settings.
- Lazy syntax styling (copy into multi-line string, etc.).
- ToolsMenu flickering.
- "grepWinNP3": optimized single-tread worker option (GRE).
- View selection on wrapped long-lines vs. normalizing view.
- Don't protect backslash (double'\\') for pattern argument.
- "grepWinNP3" ordered map of languages for selection box (GRE).
- Translatable error message format (msgbox).
- DPI scaling window on display dependent.

--------------------------------------------------------
REMOVED:
--------------------------------------------------------
- Remove DWrite Font Choose Dialog - need to type fractional font sizes manually.

--------------------------------------------------------
TRANSLATIONS (MUI):
--------------------------------------------------------
- Korean (ko-KR).
- Portuguese (pt-PT).
- Spanish Mexican (es-MX).
- Slovak (sk-SK).


========================================================
Version 5.20.411.2 (11 April 2020)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
- Executables and dll's are now signed.
- Fix DPI scaling of Toolbar bitmaps (avoid slicing by rounding errors).
- "Open with Notepad3" Right-Click in Explorer Context Menu (install/setup version).
- In About Resources: Data Sharing Service from https://workupload.com.
- Automatic scrolling when dragging selected text near window edge (SCI).
- break rectangular selection into multiple selection on end-of-lines (move caret).
- Infos of screen/display/dpi for "Copy Version Info" button.
- Preserve stream selection in file history (w/ text position remembering).
- Language dependent status bar abbreviations.
- Copy directory to clipboard and Open path in explorer.
- Toggle menu bar option.
- Add Lexicographical Line Sort Order.
- CSV Prism Color Lexer.
- Preserve File Modification Date/Time: Option stays until new session is started.
- Save with Original File Date/Time - Ctrl+Alt+F6.

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
- Change default settings for word/long-line wrapping.
- Update "KeyboardShortcuts.txt".
- Split undo typing sequence by line-breaks default -> true.
- Add file history to recent docs (taskbar) jumplist.
- NP3 INI file read/write using file locking (shared read / exclusive write) for multiple instances.
- Reset build-of-the-day number in AppVeyor on new day.
- Change version numbering of build_# (the build number is now daily based).
- Remove AppVeyors build number, add build-of-the-day number, add short version of commit/local build ID.
- Accelerator key remapping: move line up/down vs. jump folds.
- Separate auto esc'd control chars from "transform backslashes" switch in find/replace dialog.
- Increase encoding detection confidence threshold to 92%.
- Finetuning of Single Byte Char Set (SBCS) detection.
- Add current Encoding and Lexer to "Copy Version Text".
- Lexer keyword initializer list simplified.
- Find/Replace dialog: in case of "transform backslashes" do Esc control seqs.
- Upper confidence level for UCHARDET to: "AnalyzeReliableConfidenceLevel=92".
- UCHARDET: Enhanced confidence calculation for Single Byte Character Set (SBCS).
- Replace std messagebox "save modified file warning" by (silent) custom messagebox if message beeps are muted.
- Don't Auto-Close blank untitled document, only empty untitled document.
- Encoding detection fallback: if "Load ASCII as UTF-8" is checked use UTF-8 (if valid) else current ANSI code-page.
- Use Ctrl+Shift+L for toggle "Menu: Reuse Window" option.
- Inversion of Accelerator key Ctrl+Alt+L with Ctrl+Shift+L.
- Change wording "Administrator" to "Elevated".
- Hidden "ExitOnESCSkipLevel" feature (Exit on ESC can ignore a selection).
- ESC Key clears active selection (not exiting Notepad3 if configured) (Config: ExitOnESCSkipLevel=2).
- Set large file size limit to 2GB (INT32_MAX).
- Set big file size limit warning to 64MB (syntax highlighting is switched off) (Config: FileLoadWarningMB=64).
- New Notepad3 Icon (Notepad3 icon by Vexels.com designed by smanashova@gmail.com).
- Initial default big toolbar only for monitors > Full-HD.
- Copy to clipboard instead of insert (filename, path, GUID).
- Option [Settings2] LexerSQLNumberSignAsComment.
- Option [Settings2] LineCommentPortfixStrg= e.g. add a space to comment chars.
- Option [Settings2] NoCopyLineOnEmptySelection and NoCutLineOnEmptySelection.
- Appearance of INFOBOX4 (MB_YESNOCANCEL).
- Thin rectangular (multi) selection after toggling line-comment block for multi insertion.
- Full Work Area Mode (F11) -> Full Screen Mode (Maximize window if "full work area" is requested).
- Ctrl+Alt+Enter AutoCompletion behavior.
- Menu and behavior for copy/paste and copy/paste line.
- Allow each modification step to split undo typing sequence (set timeout 0 < to < 20ms).
- Split undo typing sequence (by line-breaks and/or timeout) (UndoTransactionTimeout=0, LnBrk via Menu).
- Update Oniguruma Regex (ONI) engine version 6.9.5 (2020/01/28).
- Update Scintilla Library (SCI) version 4.3.2 (2020/03/06).

--------------------------------------------------------
ENHANCEMENT:
--------------------------------------------------------
- Load files larger than 2GB (64-bit) - Limit to 4GB (Scintilla problems).
- Parameter to set document limit for big files (switch off highlighting).
- ScintillaWin: IMEJPCancelAction (SCI).
- File locking mechanism (.ini-file) to avoid multi process file write race conditions.
- Menu entries for move line and folding control.
- Multi-line Search Find/Replace.
- Apply Start Case to AutoHotkey Lexer.
- Change to 1-pass (file open/close) to save settings in Notepad3.ini.
- Enclosing selection with HTML-Tag - Remember last pattern (session).
- Repeat selection enclosing (HTML-Tag) n-times control.
- Hyperlink detection for Unicode.

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Locale dependent string comparison and Logical Number comparison.
- Review scroll behavior for context menu and Stop scrolling on context menu click.
- Do not use analysis hint UTF-8, if file is invalid UTF-8.
- Configurable default ANSI code-page (locale) detection bonus.
- No AutoCompletion on empty words (busy loop bug).
- DPI Scaling Toolbar and DPI scaling selection mode.
- Common controls will use preferred/available MUI language.
- Sticky window position handling.
- Initial, default and current window position handling.
- Debug assertion (isspace() called on non ASCII char).
- Correct return result of Styles export.
- Scintilla method declaration.
- Move hardcoded lexer <-> filename (w/o .ext) associations to configurable scheme (regex def).
- Drag&drop rectangular selection shuffles chars.
- Paint() hangs due to unnecessary LockWindowsUpdate().
- Drag&drop selection should use configured slop settings.
- Internal file-history submitted to taskbar JumpList.
- Load files larger than 2GB (64-bit) - Limit to 4GB (Scintilla problems).
- Automatic scrolling when dragging text near window edge: make caret visible after drop.
- No styling for big/large files (loading speedup and UI responsiveness).
- Esc skip level on rect/multi-selection.
- Avoid caret jump on cancel multi-selection (esc).
- In case of "Transform BS", swallow single slashes not related to a ctrl-char.
- Handling of default settings for deprecated 'SciDirectWriteTech=...'
- Concurrent access to .ini-File (lock file).
- Caret virtual space movement options: remove "SCVS_NOWRAPLINESTART".
- Jump to selection "start/end" operations.
- Word lists for LUA Lexer.
- Line Comment (Toggle) for NIM Lexer.
- Slow indentation (TAB/BACKTAB).
- AutoCompletion box.
- Find/Replace Dialog behavior.
- Transform backslashes while pasting into search/replace box.
- Some issues for lexers: YAML and JSON.
- Clipboard multi-line paste hook for Find/Replace pattern CB.
- Allow multi-line Search Find/Replace pattern.
- IME color and IME color styler.
- Wrong language reference for lexer : "Tag".
- "Recent Files" History handling.
- URL Encode/Decode (according to RFC 3986) for (Win7 API).
- Win7 "procedure entry point "SetCoalescableTimer()" could not be located.
- Wrap to Column - default=80.
- Preserve file modification time option on elevated.
- Elevated relaunch after encoding change.
- Sub dialog centering in multi monitor environment.
- Modern style message box icons.
- System MessageBox() for "not saved" warning on modified files.
- Oniguruma RegEx engine: respect EOL mode on encoding type.
- Wrong encoding detection settings for explicit config .ini-File load.
- Disable HyperLink calltip on ESC, as long as caret is in hyperlink text range.
- Crash on very large file size (rejecting too big files).
- Batch lexer: handle comment after ampersand(&) command sequence.
- Bug in replace on single step find/replace.
- Convert to Hex and vice versa: work on (stream-)selection (original source by ZuFuLiu).
- Comparison warning: signed/unsigned mismatch.
- Canonical ini-file style section order for settings from scratch.
- Prevent concurrent settings-file-access (re-launch elevated).
- Small fixes on "Relaunch Elevated" functionality.
- Minor fixes for window positioning by cmdline parameter.
- Minor correction of HotKey.
- Ctrl+Shift-C/X and Paste behavior.
- Markdown highlight overflow.
- Redo initial selection after replace (ins/del).
- Hyperlink Regex detection and Update visible indicator issue.
- Correct resource id for language sk-SK.
- Insertion handling: keep selection if non empty selection is replaced.
- TAB behavior after multi-selection undo sequence.
- Encoding tag insertion (Ctrl+F8).
- Division by zero exception (indentation and tab width).
- Selection undo/redo in case of "lean" change notify event.

--------------------------------------------------------
REMOVED:
--------------------------------------------------------
- "Ctrl+Shift+Alt+F" (Code Folding) no longer works from Windows 10 19H1 1903.

--------------------------------------------------------
TRANSLATIONS (MUI):
--------------------------------------------------------
- Swedish (sv-SE).


========================================================
Version 5.19.815.2595 (15 August 2019)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
- Add settings for allowed AutoComplete fill-up chars.
- Advanced TOML Lexer.
- Multiselect Edit Indicator.
- Color hover and picker (HTML color def only #RRGGBB, to call color-picker: Alt+MouseClick).

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
- Encoding (Default) Settings dialog: use positive wording for all items.
- Sync Minipath Filter-Lines list with Notepad3 Lexers list.
- Use double-quotes as MRU list string limiter.
- Keep .ini backward compatibility for moved "Text Files" lexer (from "Default Text").
- Update to Oniguruma (ONI) v.6.9.3.
- Scintilla Library (SCI) version 4.2.0 (2019-Jul-5).
- To force UTF-8 as preffered encoding: activate encoding detection failure fallback for default encoding.
- Allow Fixedsys font for GDI rendering.
- Color MarkOccurrences refactoring: use System's HighLight color as default (alpha:60).
- Replace Onigmo by Oniguruma (ONI).
- CED -> UCHARDET license and acknowledgement.

--------------------------------------------------------
ENHANCEMENT:
--------------------------------------------------------
- Additional information on using copy version info button of About Dialog.
- Complete implementation of UTF-8-Sig MinPath.ini file handler.
- Use UTF-8-Sig for themes files.
- Use UTF-8-Sig for .ini-File Handler (Initial Version).
- Multi-Selection with selection restore on undo.
- Bookmark margin click.
- Some multi-selection enhancements.

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Multiple checks for (invalid) operations on rectangular selection.
- Lexers with empty "associated filename ext" will be intialized with default extensions.
- Load set localized menu before displaying dialog.
- Manual entry for "Suppressed Messages" set as '-1' will hide checkbox for "Don't display again".
- Issues regarding "no Notepad3.ini" file (defaults).
- The checkbox "Don't show this DialogBox again" now remembers positive answers only.
- Message "Large File Warning" now default value for large files > 256MB.
- Send NewLine to sci control, if this id no AutoComplete fill-up char.
- Obsolete newline after .ini-file sections with comments.
- Enhanced Unicode detection.
- Oniguruma (ONI) allow CRLF as newline token.
- Notepad3.ini file, remove some keys with default values (styles).
- Extended encoding detection debug information.
- Encoding detection failure fallback: current code-page or default encoding on new (if fallback forced).
- Multi-Selection while Mark-Occurrences of current word is active.

--------------------------------------------------------
REMOVED:
--------------------------------------------------------
- Disable "NewLine" for AutoComplete fill-up.
- Remove (old) AHK Lexer in favour of modern AHK_L Lexer.

--------------------------------------------------------
TRANSLATIONS (MUI):
--------------------------------------------------------
- Polish (pl-PL).


========================================================
Version 5.19.630.2381 (30 June 2019)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
- Add another Dark Theme "Obsidian".
- Add option to disable Hyperlink Tooltip.
- ToolTip for Hyperlinks.
- 2nd Solution to build a shared library (DLL) (C++ runtime & Scintilla) version of Notepad3.
- Menu entry to mute MessageBox beeps.
- Theme Menu to load exported styles "on the fly" (e.g.: "Dark" or "Obsidian")
    Factory Default, Standard Settings, a Dark Theme.
- Close Zoom Info Bubble after ~3 sec..
- Recent History button in Toolbar.
- [Settings2] key-values (internal) to control concurrent encoding detection.
- 2nd Encoding-Detector "Mozilla's UCHARDET" concurrent to
    CED (Google's Compact Encoding Detection).
- Language selection in Main Menu .
- Command line option [/Y] to search env PATH for relative filename (NLS: strings).
- Customize Schemes: Caret style 'ovrbar' (default) to switch caret style between BAR and BLOCK .
- Highlight current line Frame-Mode (+ mode toggle Ctrl+Shift*I) (NLS: strings).
- Goto-Dlg (Line/Column) accepts TinyExpr (ignoring suffixes).
- Add CED reliability option (NLS: dialogs).
- Indentation consistency check on file open (NLS: dialogs).
- End-of-Line (EOL) consistency check on file open (NLS: dialogs).
- Checkbox for transparent Find/Replace Dialogbox on losing focus.

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
- Enable Undo on FileRevert / AutoReload.
- Adapt warning dialog according to new FileRevert / AutoReload undo/redo history.
- Add an "Always On Top" toolbar button.
- Rename "Doc Tail Chasing" => "Monitoring Log".
- Optimized FileWatching interval for "Chasing Tail" mode.
- Make "Add to Favorites" dialog resizable.
- Make Custom.Schemes and Find/Replace dialog resizable.
- BOOKMARK (margin flag) style changed to vertical flavor.
- Auto-Save after elevating user right.
- Rework Chinese encoding (GBK,GB2312,GB18030) detection and selection.
- Make international language menu (language independent).
- Start dual encoding detectors in (thread) parallel for large files
    (disabled, due to lack of performance profiling).
- Support (internal) DevDebugMode.
- Menu item "HighDPI Toolbar" -> "Toggle Toolbar".
- Train Dutch (CP-1252) for UCD language detection models.
- Train Belarusian (CP-1251) for UCD language detection models.
- Train Africaans (CP-1252) for UCD language detection models.
- Word-wrap-symbol show/hide accelerator-key -> "Ctrl+Shift+7.
- Menu Languange Selector to Dynamic Language Selector.
- Up-to-Date SCI (GitHub Mirror 2019-May-10).
- Update of CED (2019-Feb-01).
- SpeedUp of RegEx Replace (in case of const replace pattern).
- Update of Onigmo RegEx engine (2019-Jan-24).
- Optimized file search for items (filebrowser, .ini file, dirs).
- Goto-Dlg (Line/Column) shows max line number.
- SCI new Nim lexer replaces old Nimrod lexer (new highlighting).

--------------------------------------------------------
ENHANCEMENT:
--------------------------------------------------------
- Allow customizable fileName-RegEx to extensionlist
	( \rc$; = all filenames (incl. ext) which ends on 'rc').
- Hand cursor coupled with indicator hover style only on modifier keys.
- Allow indicator styling for Hyperlink hover rendering.
- Find/Replace dialog <-> "Focused View" enhancements.
- Rework inconsistent line-breaks in status bar.
- Rework EOL and Indentation check with dialogs.

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Changing .ini-file manually.
- Load external Toolbars (clear config on error, path relative to be portable).
- Focused View: refolding by lexer.
- Focused View started from Find/Replace dialog.
- Do not ignore notify change for Paste/Swap/Undo/Redo.
- Colourise bug on find next (w/ mark occurrences).
- Indentation warning dialog.
- Reworked: Consistent EOL and Indentation checks.
- Fix to support external Hot- and Disabled- Toolbar icons .
- Broken open hyperlink in web-browser (Ctrl+Click) and broken toolbar toggle.
- MUI - Replace Horizontal Ellipsis by 3 final point (ANSI Detection Issue).
- Write Language change to Settings2 on change immediately.
- Focused View not working for some Lexers.
- Find correct window for "Single File Instance".
- Single file instance: find correct window for real paths.
- Minor issue on UTF-8 encoding detection.
- High quality icon for Taskbar (big icons).
- Support high-definition icon for taskbar.
- .vcxproj files supporting VS2019 (vc142).

--------------------------------------------------------
REMOVED:
--------------------------------------------------------
- Compact Encoding Detection (CED) as 2nd encoding detector
    (rely on UCHARDET only).

--------------------------------------------------------
TRANSLATIONS (MUI):
--------------------------------------------------------
- Hungarian (hu-HU).
- Italian (it-IT).
- Korean (ko-KR).


========================================================
Version 5.19.108.1602 (8 January 2019)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
- Added initial "minipath.ini" to Visual Studio Project.
- Read undefined MiniPath settings from Notepad3.ini
    (Preferred language and Favorites directory).
- MiniPath Multilingual support.
- Handle zero-length lines in line-sorting algorithm.
- Support for "Rust" source code syntax highlighting.
- Multilingual support.
- The TinyExpr module.
- Add schema related keywords Auto Completion & IME.
- Rebuilding the "Command Line Help" dialog.

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
- Encoding Detection fine tuning.
- MiniPath About dialog: visual adjustments.
- Optimize icon resource handling.
- Optimized MiniPath resource file (icon/bitmap placement).
- Enhanced MiniPath.
- Small design change of MiniPath's Copy/Move dialog box.
- Print option "Screen Colors" now prints with the same colors
    used on screen including line numbers.
- Changed behavior of removing duplicate lines (ignore EOL/EOF chars).
- Line sorting: Move empty lines to end of selection (always, if not removed).
- Adapted PortableApps.com creator script to MUI structure.
- STD/2ND sync with DefaultText/2ndDefaultText handling.
- Reorganization of Menus in more sub-menu to shorter the Menus Lists.
- Show Zoom Percentage on magnification changes.
- Tidy Notepad3.ini to remove all defaulted [Setting] items
- Change Default settings to make the first experience of Notepad3
    more attractive...
- Open Find/Replace: Use most recent search pattern instead of clipboard
    (if selection is empty).
- Encoding affinity: UTF-8 instead of local ANSI code-page.
- Replace dialog: tmp disable "mark all occ" in case of multi-line selection.
- Adaptations for MS Visual Studio 2019 Preview.
- Scintilla updated to 412.

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Do not reset scroll-width tracking on saving file
    (issue #539: https://github.com/rizonesoft/Notepad3/issues/539).
- Fixed portable MiniPath redirector .ini files.
- Support Scintilla's new indicator box styles
    ("INDIC_GRADIENT" and "INDIC_CRADIENTCENTRE").
- Fixed incremental search on find/replace dialog.
- Fixed line sorting.
- Center commandline help dialog.
- In case of STD lexer only display "Default Text" in statusbar
    (indicator shows which one).
- Fixed resource file problem (preproc defines).
- Fixed save window Position (Default and Initial switch)
- Fixed problem with bad brace highlighting (indicator)
- if activated, ESC will close/minimize program immediately
    w/o canceling selection/tooltip first.
- Fixed broken links in About dialog.
- fixed behavior of replace (dialog) in case of multi-line selection.
- Fixed disable accelerator-key interception for universal Unicode input method.
- Fixed ASCII fallback only for selected encodings.
- Fixed Onigmo RegEx Interface: bug in returning correct matching range.

--------------------------------------------------------
TRANSLATIONS (MUI):
--------------------------------------------------------
- Afrikaans (af-ZA).
- Belarusian (be-BY).
- German (de-DE).
- English (en-GB).
- Spanish (es-ES).
- French (fr-FR).
- Japanese (ja-JP).
- Dutch (nl-NL).
- Russian (ru-RU).
- Chinese Simplified (zh-CN).


========================================================
Version 4.18.511.992 (12 May 2018)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
- Menu entries for (hidden) Accelerator Keys.
- Method to remove duplicate lines.
- Names under Acknowledgments on About box.
- Version info for Microsoft Visual C++ 2017 v15.7.(0-1) (VC v191426428).
- X-CaretPolicy ([Settings2] CurrentLineHorizontalSlop=0).
- 1st draft of "Toggle Visible" (hide non occurences lines).
- Initial version of Doc tail Chasing.
- StatusBar dynamic configuration.
- DPI awarenes on manual font scaling.
- Menu entry for switching HighDPI toolbar.

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
- Incremental match for search/replace dialog box.
- Default ini for Notepad3Portable.
- Scintilla library to v4.04.
- uthash library updated to current GitHub dev.
- Encoding of Notepad3 sources to UTF-8-Sig.
- Focus View icon.
- Prep Scintilla "Position" value type changes for large file support.
- Rebases internally used code page on UTF-8 (Scintilla multi-byte conversions).
- Renamed "Toggle View" to "Focused View".
- Replaced Tellenc by "Compact Encoding Detection" CED.
- Current Scintilla (404 : 05-May-2018) development.
- Focus View and Tail Function icons.
- Disabling UpdateChecker menu entry if no executable is configured.
- Adapted test to new Aboutbox calling.
- Menu Help instead of "?"
- Move File History (Recent File List) to Accel-Key Ctrl+Alt+H.

--------------------------------------------------------
ENHANCEMENT:
--------------------------------------------------------
- Latest compiler tool chain recognition.
- Pad with Spaces in Rectangular Selection.
- Handling of default/standard lexer styles.
- Notepad3.ini redirection to avoid overriding settings by zipped distribution.
- Added last find pattern to file history.
- Added option to remove blank lines (containing blanks/tabs only).
- Added option to skip ANSI Code Page detection (tellenc)
    (default is ON to preserve historic behavior).
- Added "Toggle View" button to toolbar.
- Compress White Spaces within rectangular selection.
- Consistent rectangular selection restauration after block operations.
- Enable "Toggle View" for main window.
- Enable "Customize Schemes" Preview button only
    if selected lexer corresponds to opened file.
- External cmd tool using Google's "Compact Encoding Detection"
    for encoding analysis.
- F/R dialog - enable "Ctrl+BS" to delete word in search string.
- File history dependent last search pattern option combined
    with search history on/off option.
- Handling of F3 (find next - no F/R dialog).
- Kind of "incremental search" : Find/Replace "Mark All Occ" active:
    typing search pattern scrolls to first match.
- Make Find Next Selected, Find Prev Selected as expected
    using modern Scintilla API methods (instead of hand made operation).
- Int to DocPos type changes.
- Indication of find/replace state in FR dialog status bar.
- Non Modal Customize Schemes... dialog.
- Show or hide passphrase in dialog box.
- Selectable (and copy-able) version info header of About-Box.
- Statusbar segmentation resizing.
- Strip First/Last Char within rectangular selection.
- Strip Trailing Spaces within rectangular selection.
- "Toggle All Folds" -> "Toggle Folds" (works on selection only too now).
- "Toggle Folds": Selection range (really) toggles folds.
- "Toggle View" coop main window vs. F/R dialog.
- Delayed "mark occurrences" multi-triggering.
- Performance tuning after profiling std. handling.
- Delayed execution of time consuming update/redraw operation.
- Added user definable relative status width configuration.
- Added settings to user defined prefix strings for StatusBar sections.
- Delayed "Spinning Circle" transaction.
- Added "Extra Line Spacing" style option to ANSI Art (e.g. .nfo files)
    (predefined -4).
- Minor speedup on notify changed event.

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Memory leakage in selection undo/redo stack.
- Remember initial search start position for incremental search.
- Some .ini-file handling stuff.
- Handling of "Mark Occ." and "Focused View"
    in cooperation with find/replace dialog.
- Select initial default standard lexer.
- Missing document modified call.
- Pad with Spaces in Rectangular Selection
    (correction for pure virtual space and skip empty lines).
- Renaming of UpdateChecker => Administration Tool.
- Issue regarding selection of default and 2nd default styling.
- Clear all occurrences marker on no matching search expression.
- Restore inital selection on search dialog canceling.
- Broken Hyperlink Hotspot handling.
- Brace matching for Batch Lexer.
- Y-CaretPolicy ([Settings2] CurrentLineVerticalSlop=0) default.
- Show replacement count info-box after UI update
    (extended selection, replaced pattern).
- Issue regarding "Auto Complete Word" feature.
- Slow pasting of multiline clipboard.
- Style_SetLexer() should update line number margin width.
- Minor issues regarding selection anchor/current_caret in Find Next/Previous.
- Remember last search pattern on new files.
- Notepad3 window positioning.
- Initial window position handling (command line option "/pos").
- Search Next (F3) handling (ver II).
- Reset scroll width on font (size) changes (automatically adapted).
- Missing menu shortcut for "Remove Duplicate Lines" ("o").
- "Remove Duplicate Lines": wrong last line handling in case of no selection.
- Using process heap allocation instead of global memory allocation method
    (according to MSDN guidelines).
- "Remove Duplicate Lines": skipping line on progress to next compare
    when removing previous duplicate.
- Toggle line comment on empty line.
- Issue in Strip First/Last Char within rectangular selection.
- Update Toolbar,Statusbar and LinNumber Margin
    on Observe NotifyEvent reactivation.
- Endless loop on "zero length match" at EOF.
- Reverting file from storage - Preserve view, cancel selection.
- Minor issue on display indication of find/replace state in FR dialog status bar.
- Small issues on Find/Replace Next/Previous operations.
- Pad with spaces in case of rectangular selection.
- HyperlinkHotspot handling while "Toggle Visibility" changes view.
- Issue with "Toggle Visibility" drawing a selection on clicking into view.
- Concurrency issue: main window vs. Find/Replace dialog.
- Folding level issue to hide non-occurrence match lines.
- Possible Deadlock.
- Avoid deadlock of occurence marker task scheduler.
- Enable FR state reset call from outside.
- Enhance indicator (redraw needed) of re-apply "Mark All Occurrences".
- "Compressed View": re-apply lexer styles on changed marked word.
- Proper view reset after reverting from compressed view.
- "Compressed View" - minor issues.
- UTF-16 LE BOM (Unicode) for Notepad3.ini. - Notepad3.ini should have
    encoding UTF-16 LE BOM (Unicode) not the smaller UTF-8 Sig encoding format.
- Scroll-to issue in case of incremental search.
- Bug replacing reverse stream selection.
- Remove file-system/URL auto-completion from search box.
- F/R dialog : minor corrections.
- Occurrences marker counting.
- default "Slop" values changed.
- Undo/Redo handling in case of discarding U/R-Stack.
- Check "Toggle View" button in case of activation.
- Restore correct fold margin.
- Optimized "notify change" observation on clearing file buffer.
- Consistent "checked" for button and menu.
- "Focused View": disable encoding identifier insertion menu entry.
- Bug in toggle mechanism of "Toggle All Folds"
- "Toggle Folds": exclude fold point (headers) which have no children.
- "Toggle Folds": selection must span at least two lines.
- Matched Rizonesoft logo background with About dialog background.
- Replace in selection: Selection enlargement.
- Version to folding issue on hiding invisible/non-marked lines.
- Toggle Folds of complete document.
- Small issue reverting from "Focused View".
- Correct WordWrap after reverting from "Focused view".
- Small bug preventing Statusbar relative width settings
    smaller than 1/10 of width.
- Missing last entry of statusbar configuration (ID=11).
- Bug while reading String to Vector.
- Switching modes (EOL,OVR, some other),
    statusbar has not been updated accordingly.
- Deactivate "Focused View": set FoldingLevel to default
    before applying Lexer's Style (-> speed-up).
- RAII (__try/__finally) for target transactions and
    notify changed observation guards.
- StatusBar handling and display of "Default text" vs. "2nd Default Text".
- Added parameter to force update of Stausbar (e.g. theme change).
- Fractional font settings: add bias of 2%.
- Minor fixes and default value adjustments.
- Choose correct font size for deactivated "Hyperlink Hotspot" style.
- Force initial default position only if no window position is specified.
- Insert key into rectangular selection.
- Undo/Redo in case of selection insert/delete.
- Cleanup obsolete rectangular pasting helpers.
- Ignore notify change event on pasting rectangular selection.
- Leave Alt-Key-Down mode if keyboard focus lost.
- Broken Undo/Redo stack (in case of selection).
- Issue on recording initial selection Undo/Redo.
- Recording selection Redo/Undo action only for non empty selection.
- Statusbar line counting display.
- Modified document flag set unneccessaryly.
- Bug, where styling stopped after hotspot highligting.

--------------------------------------------------------
REMOVED:
--------------------------------------------------------
- wyUpdate stuff from portable installation.


========================================================
Version 3.18.311.928 (11 March 2018)
========================================================

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
- Accelerator-Key to toggle tranparency mode (Alt+0 => Alt+G).


========================================================
Version 3.18.311.925 (11 March 2018)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
- New: About Box (RichEdit library 2.0)
- New: Version string patching commands for different local builds.

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
- Accelerator Keys: (Alt+0: Toggle Transparency),
    (Alt+Shift+N: Launch new empty window).
- Added "tellenc" acknowledgement to About test.
- Move "About..." dialog call to end of Help menu.
- New compiler version.
- Version info in About text.

--------------------------------------------------------
ENHANCEMENT:
--------------------------------------------------------
- Pressing F3 at Find/Replace dialog performs a find and
    switches focus to main window.

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Activation of Undo TB-Icon on operations, that can't be undone.
- Onigmo: use CR (\r) as mono line-break symbol too.
- Format number with thousand seperator and digit grouping
    acording to regional settings.
- Integration of "tellenc" encoding detection ideas.
- Use Windows regional ANSI Code Page settings for fallback in case of file
    encoding detection failure (instead of default encoding for created files).
- Use all ASCII line breaks for line termination ($) meta char.
- Onigmo backward search.
- Consider "load 7-bit ASCII as UTF-8" settings on encoding detection.
- Added BOM detection to encoding analysis.
- Issue regarding hyperlink positioning of AboutBoy in case of
    none standard sytem font styling.
- Swap clipboard while pasting into selection.


========================================================
Version 3.18.223.908 (23 February 2018)
========================================================

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Critical error with automatic updates.
- Swap clipboard bug while pasting into selection.


========================================================
Version 3.18.222.905 (22 February 2018)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
- Accelerator Key (Alt+A) to switch ON/OFF occurrences marker/counter.
- Feature "Scroll Past End of File" (settings).
- Menu entry to check Rizonesoft.com directly for updates.
- PortableApps AppCompactor call for UPX compression of NP3 binaries.
- R-Statistics Code lexer.
- Status/info bar in find/replace dialog.
- Seperator on help menu update entries.
- Styling for folding marks (charset:1 -> circles / case:U -> double lines).
- wyUpdate's client configuration to PortableApps version.

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
- Executables now compressed with NRV2E method.
- Scintilla version 4.0.3 and documentation update.
- Adapted VS compiler version string for About dialog.
- Change start of project on GitHub (date) to 2015 (Version.h).
- Compiler optimization flags for release build.
- Encoding type of Version.h from UTF-8 (Signature) to UTF-16 LE,
    to get Copyright sign right
- Folding STyle: case:L/U for box vs. circle style;
    charset:0/1/2 single line after/before/enclosing.
- Registry files lexer to support eolfilled on "Added Keys".

--------------------------------------------------------
ENHANCEMENT:
--------------------------------------------------------
- Added "Shift+F1" Accelerator Key to open "About..." box.
- Allow negative values for Extra Line Spacing (compact line view).
- Automatic Updates and incorporated launch of update installer "wyUpdate.exe".
- Changed tab-stop order while navigating several dialogs.
- Dynamic horizontal scroll bar width adaption.
- More prominent replace dialog button "In Selection".
- "Registry Files" lexer: enable attribute "eolfilled" for all styles of this lexer.
- Replace (virtual) rectangular (empty) selection.
- Wrap to Column allowed w/o selection (use complete text)
- Undo/redo stack does not need to store virtual space options.
- Check for Alt-Key down/up to allow drawing rectangular selection in virtual space.
- Use faster method (SCI direct call) to set/reset virtual space access option.

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Minor issues in context of undo/redo (virtual) rectangular (empty) selection.
- Static URL string to open version check website.
- Tidy up menu navigation via keyboard.
- Paste multi-line clipboard into rectangular selection.
- Copy/paste and redo/undo on empty/virtual rectangular selection.
- Prepare (i) for Scintilla's Position type change to 64-bit.
- Corrupted "Page Setup..." dialog layout (after changing tab-stop order).
- Pasting into rectangular selections.
- Tab-key and indentation handling.
- Indentation and rectangular selection (final solution still open).
- "Single line selection" criteria.
- Synchronized updates for Toolbar & Statusbar.
- Empty settings string, if ToolbarButtons are reset to defaults.
- Changed navigation keys for "Edit" menu.
- Set virtual space option "SCVS_NOWRAPLINESTART" for
    Alt-Key down rectangular selection only.
- Bug in calculating position for thousand separator.
- Handle case: virtual space user access not allowed.
- Selected default lexer has not been used as default startup lexer.
- Code folding integrated in margin.
- unique Style IDs.
- Disable folding operations for lexers, which don't support it.
- Default Folding Style: single line after heading.
- Bug in changed "Windows Registry Files" lexer.
- Undo/Redo action w/o selection sets/preserves selection mode (bug).
- Support styler attribute "eolfilled" in any Reg-Key case (Windows Registry Lexer).
- Small datatype correction.
- Map Toolbar Labels according to bitmap/settings file.
- Registry Files lexer: bug in GUID in Key Path with eolfilled attribute.
- Broken swap clipboard w/ selection.
- Restore selection set/replaced by replace dialog.
- Fill find/replace search box with selection/clipboard on non switching Ctrl+F/H.
- Bug detecting find/replace dialog is foreground or not.
- Initial .ini file: corrections for labeling toolbar icons.
- Performance issue: Replace All - delay status update until transaction finished.


========================================================
Version 3.18.131.862 (31 January 2018)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
- Accelerator Key "Ctrl+Alt+J" -> Fuse Lines
    (:= Join Lines, line-breaks NOT replaced by Space).
- Setting2 parameter to adjust "Mark Occ" and "Hyperlink" styling delay.

--------------------------------------------------------
ENHANCEMENT:
--------------------------------------------------------
- Highlight current line stuff gathered.
- Customize Schemes... Style Names.
- Added Accelerator Keys: Alt+LEFT/RIGHT to FOLD/EXPAND folding section.
- add empty sections to initial settings file (.ini) to force a canonical order.
- Canonical initial Notepad3.ini.
- Make selection block indentation similar to VisualStudio's.

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Performance for several modify text operations.
- Correct in-memory encoding/re-coding of text.
- Join Lines (preserve paragraphs) issue.
- Byte counting for selection.
- Bug in joining lines algorithm.
- Alt+H should open history file access dialog not help menu
    (add ? to revert to known access key).
- Revisit usage of "Mark Occurrences" and "Hyperlink Styling" delay usage.
- Rectangular selection: (virtual empty) selection persists after clear.
- Sentencecase some strings in "Customize Schemes...".
- SpeedUp undo/redo action collections.
- Lock NotifyUpdate and TargetSelection in case of multi action
    redo/undo and target replacements.
- Handling of document modified flag in case of NotifyChange bypass.
- Redo/undo and jump-to behavior having an active selection.
- Wrong test on rectangular selection.
- More select and replace target issues.
- Toggle All folds behavior.
- TAB indentation handling according to predecessors (NP2).
- selection (anchor and current caret position) handling.
- Enh: Version check for Visual Studio 2017 v.15.5.5.
- "Line Comment" id noselection and current pos == indent pos.
- Initial .ini-file: unused section removed.
- Support scintilla msg: SCN_NEEDSHOWN (EXPAND folded sections if needed).
- Avoid some issues regarding folding, using SCI_SETAUTOMATICFOLD.
- Revert TAB + Selection action corresponding to VisualStudio's behavior.
- Sensible handling of "Block -> (Un)Indent" for different kinds of selections.
- Font selection dialog does not reset some styles correctly.
- Preserve selection on Line Comment toggle.
- Char2Hex: Remove limit single byte selection.


========================================================
Version 3.18.113.828 (13 January 2018)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
- "Customize Schemes..." UI change to represent "relative sizing hierarchy".
- Initial version of Nim Lexer. Added Scintilla project and header for Nim lexer.

--------------------------------------------------------
CHANGES:
--------------------------------------------------------
- Compiler version 191225834 (VS2017 v15.5.3).
- Executables not compressed with UPX.
- Menu "Mark Occurrences" whole word matching: radio button behavior.
- Onigmo RegEx syntax dialect.
- Onigmo regex engine: use PERL 5.10 syntax +
    enable "\<" and "\>" word boundary matching.
- Option "after visible" for styling in background (idle time).
- Replace Windows Notepad Installer version only.
- View "2nd Default Style" as (dbl-clickable) status bar item.
- Word Wrap mode from WORD to SPACE to avoid wrapping at style change edges.
- Force position progress in case of zero-length matches.
- Re-introduce "max mark occurrence counter" to avoid lazy UI.
    (Set .ini section [Settings2] MarkOccurrencesMaxCount=-1 for unlimited (MAX_INT)).

--------------------------------------------------------
ENHANCEMENT:
--------------------------------------------------------
- NimLexer = NimrodLexer -> rely on Scintilla distribution for Nim(rod) lexer.
- Reasonable assumption for memory allocation of style handling (backup, save, load).
- statusbar: information about usage of 2nd Default Style.
- Statusbar: Count number of bytes in current encoding.
- structured "Mark Occurrences" menu hierarchy.
- Statusbar Partitioning.
- Cache page instead of line only.
- Mark Occurrence triggers enhancements.
- Non visible styling during idle time.
- Tuning delay parameter of "Mark Occurrences" (instantly).
- Remove test for set already, if indicator does not change.
- Redraw indicator ranges (Mark Occurrences) only if needed -
    avoiding recursive SCN_UPDATEUI notifications.

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Several Mark Occurrences (instantly) issues.
- Regarding Scheme customizing (rel. size) and View Menu (Mark Occ.).
- Onigmo regex engine PERL syntax: supporting named groups referencing
    in replacement text.
- Correct counting of found matches.
- Broken find/replace (regex) on groups.
- Some customizing scheme issues (relative font size hierarchy).
- Document modified flag not set properly (title, toolbar & statusbar only).
- Renaming menu entries Edit: "Clear" -> "Delete"
- Menu "Mark Occurrences" whole word matching: add check indicator if
    one of word matching options (selected/current) is used.
- Regex replacement on look-ahead assertion.
- relative font sizing of non-default-style entries in custom schemes.
- Font selection box title display.
- clean coding for "relative sizing hierarchy".
- Update view on style change in "Customize schemes..."
- Bug regarding "Reset" button in "Customizing Schemes..." dialog.
- Bug in detect and style Hyperlink Hotspot.
- Losing state of "Transform Backslashes" while switching regex/wildcard search.
- Block "mark occurrences" event on transaction pair:
    (SCI_TARGETFROMSELECTIO, SCI_REPLACETARGET).
- protect SCI target transactions by a guard to break recursion of
    Mark Occurrences caused by ChangeNotification() events.
- Handle "2nd Default Styles" as separate standard (2nd) lexer module.
- Handling initial 1st or 2nd default style in case of "Default Text",
    shown on int "Customize Schemes...".
- Crash on navigation between schemes beyond start/end of tree view.
- Disable (using 1st Default Style)
    "Associated filename extensions" for "2nd Default Style".
- Clone associated filename extension list of Default Style (for 2nd Default Style).
- move word wrap start symbol to margin (new WW mode SPACE (instead of WORD))".
- Mark Occurrences timeout on Find/Replace.
- Optimized status bar partitioning.
- Revert naming for "2nd Default Text".
- Bug on switching between 1st and 2nd standard lexers.
- Selection of 1st or 2nd standard lexer (Default Text) based on Use2ndStandard flag.


========================================================
Version 3.18.105.802 (5 January 2018)
========================================================

--------------------------------------------------------
NEW:
--------------------------------------------------------
- New: Hyperlink Hotspot Style updates on UpdateUI event (visible area only)
- New: Switch to draw all occurrences in visible area only.
- New: (Mark Occurences) instant word highligting.

--------------------------------------------------------
ENHANCEMENT:
--------------------------------------------------------
- Async mark all occurrences via timer (UI response).
- Delayed mark all occurrences for better UI response.
- Fixed some issuses, which eat up CPU.
- Optimizing timer handling to avoid multiple calls of complex methods.

--------------------------------------------------------
FIXES:
--------------------------------------------------------
- Custom toolbar images ini settings added.
- Add hints for free text style properties in "Customize Schemes...".
- Test version numbers for month Jan - Sep (mono digit).
- Redundant echo of expected version string.
- Toggle line comments were placed at line end.
- "Match Current Word" should not highlight partial word matches in other lines.
- Fetching wrong visible document line number in case of hidden or wrapped lines.
- Ignoring queued timer event, if timer has been killed.
- use current lexer's default text font size as base font size for
    relative sizing of other styles.
- mark occurrences counter not updated in time.


========================================================
Version 3.17.1228.783 (28 December 2017)
========================================================
- New: Added batch script to bulk encrypt files of given directory with encryption tool.
- New: inticator style used for matching braces too.
- New: Java sourcecode to compile a class which acts as a standalone tool for decrypting Notepad3's encrypted files.
- New: Regex - "Dot matches all" vs. "Dot does not match line-breaks" switchable by option in find/replace dialog.
- Fix: Update coloring on window message WM_SYSCOLORCHANGE, including Hyperlink hotspot colors.
- Fix: Crash on empty password for encryption tool.
- Fix: Existing bash test script for encryption tool.
- Fix: Onigmo regex: . matches any charakter and does not stop at line breaks.
- Fix: Onigmo regex: remove extend mode, where # is used as line rest comment.
- Fix: Change hard coded default values for matching brace styling according to new style (indicator).
- Fix: font styling of Hyperlinks are not reset to default if feature is switched off.


========================================================
Version 3.17.1223.778 (23 December 2017)
========================================================
- New: More triggers for Hyperlink style updated.
- New: Online Documentation menu item.
- New: Added Scintilla's indicator styles to scheme config for "Mark Occurences".
- New: Dual configuration of Default Text Font or Current Scheme's Default Text Font.
- New: Replaced DeelX with Onigmo regular expression engine.
- Changed: uthash to version 2.0.2.
- Changed: Enhanced style copy method.
- Fix: Minor fixes for Onigmo interface class.
- Fix: Hyperlink feature related delay of font changing.
- Fix: Last hyperlink was restyled to lexer's style (not desired hotspot style).
- Fix: Default lexer style changed a litle bit after first UI update.
- Fix: Redraw bug in case of SCI_COLOURISE.
- Fix: Removed some Hyperlink dection triggerpoints, which might be collide with SEARCHINTARGET and REPLACETARGET race conditions (seperate threads).
- Fix: Removed unneccessary Hyperlink trigger-point from InitInstance().
- Fix: Performance issue while pasting long text from clipboard.
- Fix: Local memory freeing.
- Fix: Complete set of font weights for syntax scheme.
- Fix: Prepare fixing race-condition search/replace target vs. selection.
- Fix: Set target range only for search/replace and not for paste after modifying selection (race-condition search/replace target vs. selection).
- Fix: Transform backslashes for regex find/replace.
- Fix: Out of range fallback for indicator string retrieval.
- Fix: Issue regarding TransformBackslash handler (regex vs. std & find vs. replace).
- Fix: Replace dialog: Resize regex text box to not overlay other control.
- Fix: Enable more hyperlink styling trigger points, since "replace target" race-conditions have been fixed and fast regex engine (Onigmo) is integrated.
- Fix: Issue regarding applying lexer style while hyperlink feature is active.
- Fix: Reverting to buffered draw, until screen flickering issues are clarified.
- Fix: Onigmo regex engine handling string/line end meta char '$' independent of EOL mode.
- Fix: Replace-all with look-behind assertion.
- Fix: Onigmo word boundaries issues (incl. "double" escaped esc) (not solved yet: multi escaped esc).
- Fix: Customize schemes issues (now Default Font: is applied to "Default Text" and "Current Lexers" Default Font).
- Fix: Allow (horiz.)TAB chars in selection copied to find/replace dialog search box on pop up time (Ctrl+F).
- Fix: Setting "Default Font..." will clear current lexer's default font - inherits global default font then.
- Fix: "Default Font..." configuration issue.
- Fix: "Default Font..." add check for current scheme is not default text already.
- Fix: Schemes in alphabetical order (displayed names).
- Fix: Bug on font selection - global vs. current scheme.
- Fix: More bugs regarding standard lexer handling.
- Fix: Using WYSIWYG fonts (screen vs. printer).
- Fix: Inconsistencies: cut,copy,replace,... mainmenu and context menu vs. toolbar.
- Fix: New Font selection New: 2nd Default Font not supported completely.
- Fix: setting/changing encryption pass-phrase did not trigger "file modified" flag.
- Fix: Problem with 1st vs. 2nd Default Text Scheme selection.
- Fix: Inconsistency 1st vs. 2nd Default Text Font selection.
- Fix: Use Standard Lexer on new (empty) files.
- Fix: General bug fixes and code cleanup.


========================================================
Version 3.17.1210.729 (10 December 2017)
========================================================
- New: Added Awk Script syntax highlighting (Python lexer based)
- New: Enhanced URL Hotspot highlighting.
- New: open Hyperlink in NP3 (if applicable: "file://...").
- New: Update notification in Notepad3 setup.
- New: URL Hotspot (first version).
- Changed: [Settings2] section default values (and comment out if not changed) of initially distributed Notepad3.ini
- Enhancement: Code Cleanup
- Fix: Edit/Special : URL encoding/decoding for full UTF-8 (non ASCII) characters.
- Fix: flashing of Search text-box of find/replace dialog in case of Win7 Classic theme
- Fix: Gibberish output if URL decoded again (2nd time).
- Fix: URL decoding, if encoding has "%#nnn" formatted ASCII chars.
- Fix: HTML character encoding starts with ampersand, not percent char.
- Fix: URL encoding: Added flag URL_ESCAPE_PERCENT for UrlEscape().
- Fix: Added version info for VS2017 v.15.5
- Fix: Consistent texts for "Hyperlink Hotspots".
- Fix: Hyperlink Hotspots turned off by default. (not stable enough to force the feature).
- Fix: Normal setup can now clean replace Windows Notepad registry keys.
- Fix: Added some more places, where Hotspot style redrawing does not slow down responsiveness.


========================================================
Version 3.17.1202.715 (2 December 2017)
========================================================
- New: Additionally show full path to current directory in windows title.
- Changed: Move "Mark Occurrences" check box from menu to find/replace dialog options.
- Changed: Renaming of drag n' drop methods.
- Fix: Removed unused mouse wheel message interception.
- Fix: Disabling buffered draw. (Scintilla: "Current platforms perform window buffering so it is almost always better for this option to be turned off.")
- Fix: Font Smoothing: [Settings2] SciFontQuality=n has no effect on some special fonts (preserving old behavior if not defined).
- Fix: Adapt text for messagebox: no valid drop-file.
- Fix: issue regarding Accelerator keys for find/replace dialog.
- Fix: Minipath full path display in titlebar (no dbl-slash in case of drive letter only).
- Fix: Mark occurrences: Outline frame of indicator box shouls have same aplpha channel color (configurable alpha2:nnn).
- Fix: Find/replace dialog: mark occurrences: use standard save/restore settings behavior.
- Fix: #192 Drag n' drop from 32-bit process on Notepad3 x64 window


========================================================
Version 3.17.1124.690 (24 November 2017)
========================================================
- Added Book Mark style (Color Background and Alpha) to customize schemes...
- New "D" and "Go" programming language support.
- Update: Compiler version detection.
- Update: Scintilla Lib v.4.0.2 (402).
- Adapt: C/C++ styles - keyword vs. typedefs.
- Changed SDK version target to 10.0.16299.0
- Major refactoring of find/replace regex evaluation.
- Optimized DeelX regex interface.
- Minor fix for DeelX RegEx engine.
- Move position after replacement (EditReplace()).
- Refactoring of "Replace All" methods.
- Split C++ Keywords in two parts (1st: standard keywords, 2nd: keywords starting with double underscore "__xxx").
- Minor polish of Readme.md.
- Put changes compared to Notepad2-mod into Readme.md.
- Repair empty resource file (Notepad3.rc).
- Bookmark Enhancements
- Replaced old bookmark pixmap (visible margin) by Scintilla's BOOKMARK marker style.
- Swap text fields in Find/Replace dialog.
- Enhance: comments with useful web links.
- Enhance: Increase buffers for edit box in "Customize Schemes..." dialog.
- New: Auto remember bookmarks in recent file history.
- New: find/replace mark occurrences.
- New: Indicator in find text box, if search string is matched in document.
- New: Mark occurrences coloring is now configurable via "Customize Schemes...".
- New: "Swap Strings" button in Find/Replace dialog.
- New: validate regexpr.
- Fix: Revert to Scintilla's default mouse down and mouse wheel capture mode.
- Fix: "Mark All Occurrences" setting of find/replace dialog should only be persisted, if "Save Settings on Exit" is enabled.
- Fix: UpdateLineNumberWidth() triggers cleanup.
- Fix: Issue with update of line number margin width.
- Fix: Transform backslash issues.
- Fix: C/C++ keywords and types.
- Timer call for mark occurrences during find/replace.
- Fix: lookaround regex (DeelX) matches were not replaced.
- Fix: Issue regarding find/replace empty-string.
- Fix: Adapt DeelX RE interface according to enhanced find/replace dialog.
- Fix: Issue #173 - regex/wildcard search: replacement string not used if "Check All Occurrences" is active.
- Fix: Recoding minipath's version.h to UTF-8-Sig, because it contains codepage dependant copyright sign.
- Fix: Corrections to .vcproj settings inconsistencies (reported in release build process).
- Fix: undo/redo issues (if no selection choosen).
- Fix: Consecutive DEL/BACKSP undo/redo broken (wrapped by unconditional selection undo/redo).
- Fix: Issues found by static code analysis.
- Fix: Bug in getting string length from dialog box readout.
- Fix: Break criteria for "replace all in range".
- Fix: Issues found regarding zero-length matches using regex anchors, including infinite loops on replace all.
- Fix: RegEx start anchor adjustment.
- Fix: Problem with regex line start and replacements at line end.
- Fix: Issues regarding selection undo/redo.
- Fix: Issues regarding margins configuration.
- Fix: Issue #139 and #143 (remove selection undo/redo for non-text-changing operations on selections).
- Fix: issue #144 (Left arrow no longer moves to previous line).
- Fix: issue #145 (Mark Occurrences Counter is broken).
- Fix: Pasting clipboard content into selection box should replace text and cancel selection then.
- Minor bug fixes and more...


========================================================
Version 2.17.1023.632 (23 October 2017)
========================================================
- Add code snippet (activation only prepare for future extensions).
- Added switch ([Settings2] UseOldStyleBraceMatching) to preserve old style
    brace matching behavior.
- Applied patch from Neil Hodgson (Master of Scintilla Lib - respond to
    scintilla lib issue report #1976).
- Changed buffers for operating edit box in customize schemes.
- Documentation: Minor changes to Notepad3.txt.
- Documentation: doc/Notepad3.txt - add description of [Section2] .ini settings
    (mostly taken from orig. Notepad2 FAQs).
- Default to modern displays settings, using Scintilla's new technology
    : SciDirectWriteTech=1, SciFontQuality=3
- First prottotype of VirtualSpace RectangularSelection by default (very old
    behavior can be turned on by [Settings2] DenyVirtualSpaceAccess=1).
- Implemented Feature Request #51 (buffer size of file extension edit box).
- New: Show warning before loading file with unknown (custom schemes) file name extension.
- License.txt: switch to UTF-8 encoding.
- Restore wrongly discarded np3portableapps .ini files for NP3Portable,
    redirecting .ini reading to correct path.
- Small code refactoring (replacing deprecated methods).
- Settings [Section2] (cannot be set via GUI) add all possible names and
    default values, if applicable.
- Fixed .ini paths for np3portableapps.
- Fix: Crash in Favorites management.
- Fix: pasting clipboard content into selection box should replace text and
    cancel selection then (in case of swapping clipboard, the selection is preserved).
- Remove settings for "Favorites" directory -> NP3 uses then users system
    default folder (%USERPROFILE%\Favorites).


========================================================
Version 2.17.1016.610 (16 October 2017)
========================================================
- Added remove button for list items.
- Checkbox for "preserve caret position" settings.
- File History Dlg: rename button "Remove" -> "Discard"
    (discard selected item from file history list).
- Minor bugfixes for session feature
    (file history: remember caret pos and encoding).
- Removed unnecessary build artifacts from np3portable.


========================================================
Version 2 Build 605 (15 October 2017)
========================================================
- Fix: Crash on accessing UndoRedo structure while NP3 instance has
    not been initialized completely (.LOG file opening bug).


========================================================
Version 2 Build 600 (15 October 2017)
========================================================
- Fix: Virtual space access: column indicator.
- Fix: Customize Schemes... Font... selection: bold/italic now detected
    (bold: if selection >= FW_SEMIBOLD)


========================================================
Version 2 Build 583 (11 October 2017)
========================================================
- Cleanup AHK testing script, add test artifacts.
- Generalized internal multi-byte codepage definitions (code cleanup).
- Fix: syntax error on exit script.
- Fix: Try to retrieve correct file version for Notepad3Portable creator.
- Fix: StatusBar Col display is not correct in case of Virtual Space Access.
- Fix: locale / language independant version patching batch for Notepad3Portable
- Fix: version patching for Notepad3 PortableApps build batch.
- Fix: Recode to ANSI (in case of Chinese ANSI code-page)


========================================================
Version 2 Build 568 (8 October 2017)
========================================================
- Updated the Run Dialog icon.
- Code comment for completeness.
- Enhanced clipboard recoding detection.
- Prettier Browse Icon.
- StatusBar information enhancements.
- Fix: Reverting "reload as UTF-8 not work bugfix".
- Fix: Texture glitch on "Browse" button.
- Fix: Binary directory to build portable app.
- Fix: In-text encoding (convert encoding).
- Fix: minor StatusBar string corrections.
- Fix: Support pasting position at virtual space.
- Fix: Move caret to convenient position after pasting clipboard (no current selection).
- Fix: Virtual space navigation and rectangular selection (allow "Virtual Space Rectangular Selection"
    also allows moving Caret into virtual space (beyond line end))
- Fix: Copy/Cut & Paste of current line (in case of no selection
- Visual Studio behavior - using SCI's MSDEVLineSelect).
- Fix: Bug in code-page related text conversion.


========================================================
Version 2 Build 548 (3 October 2017)
========================================================
- Code cleanup
- Fix: Made corrections to build 505 change log (spelling, grammar, etc).
- Fix: FILE status becomes [MODIFIED] when doing CONTROL+A to select ALL.
- Fix: Paste from clipboard to ANSI code page:
    unnecessary switching encoding to UTF-8.
- Fix: Undo/Redo of virtual space selection rectangle not correct.
- Fix: StatusBar SelectionCount (Sel) : count chars instead of bytes.
- Fix: Punctuation chars for "Accelerated Word Navigation" (Settings2:
    ExtendedWhiteSpaceChars= add non word chars here).
- Fix: Do mouse wheel scrolling in editor area only.
- Fix: DPI awareness in manifest.
- Fix: word delimiter in case of "Accelerated Word Navigation".
- Correct UFT Spelling on Encoding menu.


========================================================
Version 2 Build 505 (23 September 2017)
========================================================
- 1st chunk of StrSafe migration.
- Some more StrSafe changes
- Fix: manually edited settings (SciDirectWriteTech, SciFontQuality)
    should be placed in settings section [Settings2].
- Extended default "space char set" for "Accelerated Word Navigation" to avoid
    unexpected "accelerated word navigation" behavior, space-char extension is
    restricted to 7-bit ASCII char set (ignoring specified non-7-bit-ASCII chars).
- StrSafe adaptions
- Fixed: settings SciFontQuality have been overwritten by Scheme configuration.
    (Fonts: Calibri, Cambria, Candara, Consolas, Constantia, Corbel, Segoe UI are using
    'cleartype smoothing' (SC_EFF_QUALITY_LCD_OPTIMIZED) by default, if not
    configured in Schema definition for Lexer)
- Added font "Source Code Pro" to list of special fonts for cleartype smoothing.
- Fix: undo destructive operation on selection (rectangle) does not restore
    selection or preserves selection mode (extends selection on caret movement)
    -> need to send SCI_CANCEL at the end of restored selection.
- Found bug caused by StrSafe migration
    (COUNTOF() for buffer size must not be used on buffer pointer)
- migrate StrCpyN() and StrCatBuff() to corresponding StrSafe.h methods
- Adapted lstrcpyn() calls according to StrSafe.h requirements.
- Refactoring of "Accelerated Word Navigation" to be compliant with Scintillas
    WhiteSpace and Punctuation defines.
- "Accelerated Word Navigation" activation influences "Mark Occurrences" (whole word) if set
- Extended: Remember selection undo / redo
- Added undo / redo selection to more operations
- Found Scintilla 400 method "SCI_CUT" (cut selection) broken: lost last char
    replaced by SCI_COPY & SCI_CLEAR combination (for now).
- changes to EditGetClipboardText() solved the SCI_CUT problem, so it can be switched back
    from SCI_COPY & SCI_CLEAR to SCI_CUT (byte alignment in 64-bit, i am nut sure)
- switching Scintilla internal codepage to UTF-8 only (resp. Japanese,
    Chinese and Korean DBCS) single-byte encoding is supported externally and
    converted (fore and back) to UTF-8 internally, this simplifies i.e. clipboard exchange, etc.
- Removed support for obsolete Korean Johab (1361) codepage.
- Fixed ConvertText() according to internal SCI codepage
- Refactoring: Encoding handling
- More operations for selections undo/redo.
- Enabled "unlimited" (as in Scintilla Lib: dep. on memory and INT_MAX)
    undo / redo selection history using utarray from uthash header library
    (https://troydhanson.github.io/uthash/index.html)
- Moved crypto readme to doc dir
- remove internal codepage support for Chinese, Japan, Korean DBCS use
    generalized UTF-8 codepage instead
    (conversions do not work as expected within scintilla lib)
- Dropping Windows XP support , using compiler toolset vc141 Win SDK 10.0.
    (current VC++ redistributable needed?)
- Replaced lstrcmp() and lstrcmpi() by StrSafe (helper.h defined) methods.
- Relaunch elevated keeping current changes in a buffer.
- Fixed some problems for feature "relaunch elevated preserve changes".
- First AppVeyor config
- Remember window position in case of "relaunch elevated".
- Fixed memory initialization problem during InitInstance()
- Enhanced consistency between toolbar (save button) and titlebar (modified marker)
- "Relaunch elevated": use current .ini-file instead of new user's (Admin's) .ini
- Cleanup tmp filebuffer, if elevation has been rejected.
- Fixed crash in case of wrong Encoding (detection)
- Changed version display on Help/About.
- New Powershell script to patch version numbers
- appveyor.yml using same powershell commands to patch version
- Remove FindReplaceDlg handle declared as external from compilation unit Edit.c not really needed here.
    (externals (handles / pointers) seemed to be a problem on module init instance time in 64-bit)
- Fixed: Open find dialog the first time (new NP3 instance) while
    clipboard is empty, NP3 crashes (try to LocalFree() static allocated memory)
- Fixed: RegExpr "Find previous" corrected (find mode "left to right" has been
    used, which has not the intended behavior).
- Updated Compiler Info.
- Added build.txt (and .ps1 changes) for Local Build Version patching
    (common AppVeyor/Local script).
- Fixed issue "Convert to Title Case" while selected text is all upper case.
- Fixed broken "Complete Word" feature (Ctrl+Enter/Return).
- Changed accelerator key for feature "Complete Word" from Ctrl+Enter to Ctrl+Alt+Enter.
- Added feature "Insert New (empty) Line above current line Ctrl+Enter (as in VisualStudio).
- Code cleanup
- Added new Settings "Virtual Space on Rectangular Selection" used to select.
    rectangle not delimited by line endings (but including virtual space).
- Readme.txt Updated. (Thanks Will)


========================================================
Version 2 Build 450 (18 August 2017)
========================================================
- Update to Scintilla 400 (early bird) pre-release.
- Renamed encoding menu item: "Recode No FileVars" (Alt+F8) =>> "Ignore Encoding Tags" (Alt-F8)
- UTF-8 encoding of License.txt (fixing: different ANSI codepage for copyright sign)
- Fixed "file modified" flag not set on Ctrl+X actions
- Fixed re-enable accidentally disabled toolbar buttons (find, replace, clear, toggle-folds, file-launch)
- Fixed remove obsolete settings entry, never read (SciDrawTechnology)
- Fixed crash: not a good idea to make char array (char*) external to other compilation unit.
- Fixed wrong shortcut in menu on word navigation (Ctrl+LEFT/RIGHT)


========================================================
Version 2 Build 440 (16 August 2017)
========================================================
- Added Enabling/Disabling Save-Button in toolbar according to file modified indicator.
- Added Del/Back Selection preserving on Undo/Redo
- Cut Selection (Ctrl-X) will preserve Selection on Undo/Redo
- Zero initializing string buffers (hardening code while searching an issue regarding "Recent Files" list in "relative paths" mode
- Menu integration of "hidden" commands
- Fixed unicode conversion error fixed in .rc
- Fixed Toolbar Button "Save" has to be enabled on encoding changes
- Fixed bug on path compare for editing own settings file (.ini) to disable "save settings" menu entries (should be case insensitive)
- Fixed: restore "rectangular" selection too on "Selection Cut" Undo/Redo
- Fixing and cleanup build for Notepad3Portable


========================================================
Version 2 Build 432 (10 August 2017)
========================================================
- Added command line option ( /v ) to print file immediately and quit (like Window's original notepad.exe /p option).
- Added printing additional option /v dialog to allow access to the Printer dialog (as on Menu: Print... ).
- Enlarge some string buffers for dialogs.
- Initial version of PortableApps.com Launche and Installer build.
- Build environment, to create Notepad3Portable (according to Portableapps.com) (x86/x64).
- Fixed issue #35 (preserve FileExtension settings while switching Styles / 2nd Default Scheme).
- Fixed np3encrypt vcxproj files.


========================================================
Version 2 Build 422 (10 August 2017)
========================================================
- Cleanup manifest handling
- Minipath DPI aware false


========================================================
Version 2 Build 411 (9 August 2017)
========================================================
- Added VisualStudio's Editor Behaviour for Ctrl-C and Ctrl-X
- Added VS2017 .vcproj files and adapted Compiler Tool Set accordingly
- Reintroduce HighDPI toolbar
- Integrate Scintillas DirectWrite technology
- Minor cleanups reported by CppCheck v.1.79
- Fixed nullptr access while pressing "favorites" toolbar button on 'virgin' Notepad3 ToolBar
- Fixed broken Ctrl-Q (toggle line comments)


========================================================
Version 2 Build 398 (13 June 2017)
========================================================
- Added Microsoft Visual C++ 2017 (vc141) support.
- Updated Scintilla to version 3.7.5
- Don't use 2nd default syntax scheme by default. (Issue #21)
- Bigger Toolbar Buttons (24px). Should be big enough now. (Issue #21)


========================================================
Version 1 Build 388 (06 January 2017)
========================================================
- Updated Scintilla to version 3.7.2
- MiniPath now works on Windows XP


========================================================
Version 1 Build 386 (08 December 2016)
========================================================
- Added RaPeHoff to the contributors list.
- Update to Scintilla 371 (NP2 adaption due to deprecated data types).
- Clean-code Solution (instead of "magic numbers").
- Crypto Module: code cleanup
- Crypto Module: Replaced LocalAlloc/GlobalAlloc by HeapAlloc methods.
- Integration of DeelX RegExpr engine (http://www.regexlab.com/en/deelx)
- Fixed block selecting cause crash.


========================================================
Version 1 Build 350 (05 September 2016)
========================================================
- Added Microsoft Visual C++ Update 3 version number
- Updated HTML Keywords
- Updated Scintilla to version 3.6.7


========================================================
Version 1 Build 330 (24 June 2016)
========================================================
- Added Visual Studio 2015 Update 2 version number
- Added Support for Inno Setup 5.5.9
- Implemented a new versioning scheme
- Updated Apache Keywords for version 2.4
- Updated to Scintilla 3.6.6
- Updated Rizonesoft Versions Program
- Fixed Compiler warnings
- Fixed Favorites Function
- Removed Visual Studio 2010 to 2013 Support



